#include <stdio.h>

#include <osbind.h>

#include <time.h>

#include <bios.h>



extern char hline, vline, ltop, lbot, rtop, rbot;



display_board(fd, output, local, jgame, revon, revoff, turn, white, black, alias, view, maxdays)



int fd; char *output; int local, jgame; char *revon, *revoff, *turn;

char *white, *black, *alias, *view; int maxdays;



{



    char space[10];



    int n, i, box, rank, add, row, line;

    long daysleft, secs, hours, mins;

    time_t curdate;



    struct {

        char square[65];

        int move;

        time_t move_date;

        char last_move[6];

        int d_pawn_move;

        int check;

        int wpoints;

        int bpoints;

        int draw;

        int wking, bking;

        int wqrook, wkrook, bqrook, bkrook;

        int wdraw, bdraw;

    } board;



    board.square[0] = board.move = board.last_move[0] = 0;

    board.d_pawn_move = board.check = board.wpoints = board.bpoints = 0;

    board.draw = board.wking = board.bking = board.wqrook = 0;

    board.wkrook = board.bqrook = board.bkrook = board.move_date = 0;

    board.wdraw = board.bdraw = 0;



    line = 0;



    if (pnmatch(view, "White", 0)) {

        rank = 9;

        box = 63;

        add = 1;

        row = -8;

    }



    else {

        rank = 0;

        box = 0;

        add = -1;

        row = 8;

    }



    space[0] = 0;



    Fseek(0L, fd, 0);



    Fread(fd, (long) sizeof(board), &board);



    time(&curdate);



    daysleft = (board.move_date - curdate)/86400L;

    secs = (board.move_date - curdate) - (daysleft * 86400L);

    hours = secs / 3600;

    mins = (secs - (hours * 3600)) / 60;



    if (!write_line("\r\n", local))

        return(0);



    board_top(local);



    sprintf(output, "\r\n");



    if (!write_line(output, local))

        return(0);



    for(n=0;n<4;n++) {



        write_line(" ", local);



        v_line(local);



        for(i=0;i<4;i++) {

            rev_on(revon, local);

            if (!write_line("    ", local)) {

                rev_off(revoff, local);

                return(0);

            }

            rev_off(revoff, local);

            if (!write_line("    ", local))

                return(0);

        }



        v_line(local);



        line++;



        if (line == 1) {

            sprintf(output, "     Game No: %d", jgame);

            if (!write_line(output, local))

                return(0);

        }



        if (line == 9) {

            sprintf(output, "     Last Move: %s", board.last_move);

            if (!write_line(output, local))

                return(0);

        }



        if (!write_line("\r\n", local))

            return(0);



        rank -= add;

        sprintf(output, "%d", rank);

        if (!write_line(output, local))

            return(0);



        v_line(local);



        box += row;



        for(i=0;i<4;i++) {

            box += add;

            get_piece(space, board.square[box]);

            rev_on(revon, local);

            if (!write_line(space, local)) {

                rev_off(revoff, local);

                return(0);

            }

            box += add;

            get_piece(space, board.square[box]);

            rev_off(revoff, local);

            if (!write_line(space, local))

                return(0);

        }



        box += row;



        v_line(local);



        line++;



        if (line == 6) {

            sprintf(output, "     Move No:   %d", board.move);

            if (!write_line(output, local))

                return(0);

        }



        if (line == 14) {

            if (pnmatch(turn, "White", 0) && pnmatch(white, alias, 0) || pnmatch(turn, "Black", 0) && pnmatch(black, alias, 0)) {

                if (!write_line("     It's your move.", local))

                    return(0);

            }



            else {

                sprintf(output, "     It's %s's move.", turn);

                if (!write_line(output, local))

                    return(0);

            }

        }



        write_line("\r\n ", local);



        v_line(local);



        for (i=0;i<4;i++) {

            rev_off(revoff, local);

            if (!write_line("    ", local))

                return(0);

            rev_on(revon, local);

            if (!write_line("    ", local)) {

                rev_off(revoff, local);

                return(0);

            }

        }



        rev_off(revoff, local);



        v_line(local);



        line++;



        if (line == 3) {

            sprintf(output, "     White: %s", white);

            if (!write_line(output, local))

                return(0);

        }



        if (line == 7) {

            if (!write_line("     Time Left: ", local))

                return(0);



            if (daysleft >= 0)

                sprintf(output, "%ld days %ld hrs %ld mins", daysleft, hours, mins);



            if (daysleft < 0)

                sprintf(output, "Expired");



            if (!write_line(output, local))

                return(0);



        }



        if (line == 11) {

            sprintf(output, "     White's Points: %d", board.wpoints);

            if (!write_line(output, local))

                return(0);

        }



        if (!write_line("\r\n", local))

            return(0);



        rank -= add;

        sprintf(output, "%d", rank);

        if (!write_line(output, local))

            return(0);



        v_line(local);



        box += row;



        for (i=0;i<4;i++) {

            box += add;

            get_piece(space, board.square[box]);

            rev_off(revoff, local);

            if (!write_line(space, local))

                return(0);

            box += add;

            get_piece(space, board.square[box]);

            rev_on(revon, local);

            if (!write_line(space, local)) {

                rev_off(revoff, local);

                return(0);

            }

        }



        box += row; /* used to make board display from left to right */



        rev_off(revoff, local);



        line++;



        v_line(local);



        if (line == 4) {

            sprintf(output, "     Black: %s", black);

            if (!write_line(output, local))

                return(0);

        }



        if (line == 12) {

            sprintf(output, "     Black's Points: %d", board.bpoints);

            if (!write_line(output, local))

                return(0);

        }



        if (line == 16 && board.check == 1) {

            if (pnmatch(turn, "White", 0) && pnmatch(white, alias, 0) || pnmatch(turn, "Black", 0) && pnmatch(black, alias, 0)) {

                if (!write_line("     You are in check.", local))

                    return(0);

            }



            else {

                sprintf(output, "     %s is in check.", turn);

                if (!write_line(output, local))

                    return(0);

            }

        }



        if (!write_line("\r\n", local))

            return(0);



    }



    board_bot(local);



    sprintf(output, "\r\n");



    if (!write_line(output, local))

        return(0);



    if (pnmatch(view, "White", 0)) {

        if (!write_line("   A   B   C   D   E   F   G   H\r\n", local))

            return(0);

    }



    else {

        if (!write_line("   H   G   F   E   D   C   B   A\r\n", local))

            return(0);

    }



    return(1);



}



board_top(local) int local;



{



    int i;



    write_char(' ', local);

    if (local == 1)

        write_char(' ', 2);



    write_char(ltop, local);



    if (local == 1)

        write_char('\360', 2);



    for (i=0;i<32;i++) {

        write_char(hline, local);

        if (local == 1)

            write_char('\360', 2);

    }



    write_char(rtop, local);

    if (local == 1)

        write_char('\360', 2);



}



board_bot(local) int local;



{



    int i;



    write_char(' ', local);

    if (local == 1)

        write_char(' ', 2);



    write_char(lbot, local);



    if (local == 1)

        write_char('\360', 2);



    for (i=0;i<32;i++) {

        write_char(hline, local);

        if (local == 1)

            write_char('\360', 2);

    }



    write_char(rbot, local);

    if (local == 1)

        write_char('\360', 2);



}



v_line(local) int local;



{



    write_char(vline, local);

    if (local == 1)

        write_char('|', 2);



}



write_char(c, local) char c; int local;



{



        if (local == 1 && cd_check() == 0)

            exit(0);



        while(Bcostat(local) == 0)

            continue;



        Bconout(local, c);



}



get_piece(space, square) char *space, square;



{



    if (square == ' ')

        strcpy(space, "    ");

    if (square == 'R')

        strcpy(space, " WR ");

    if (square == 'r')

        strcpy(space, " BR ");

    if (square == 'N')

        strcpy(space, " WN ");

    if (square == 'n')

        strcpy(space, " BN ");

    if (square == 'B')

        strcpy(space, " WB ");

    if (square == 'b')

        strcpy(space, " BB ");

    if (square == 'Q')

        strcpy(space, " WQ ");

    if (square == 'q')

        strcpy(space, " BQ ");

    if (square == 'K')

        strcpy(space, " WK ");

    if (square == 'k')

        strcpy(space, " BK ");

    if (square == 'P')

        strcpy(space, " WP ");

    if (square == 'p')

        strcpy(space, " BP ");



}

