#include <bios.h>

#include <osbind.h>

#include <time.h>

#include <stdio.h>



char noise[] = {

    0, 4, /* 246 */

    1, 4,

    2, 3,

    3, 3,

    4, 2,

    5, 2,

    6, 0, /* 0 noise period */

    7, 248,

    8, 9,

    9, 12,

    10, 15,

    11, 0,

    12, 48, /* 48 period of voice C */

    13, 9, /* 9 shape/cycle */

    255, 10,

    7, 63,

    255, 0

};



struct configuration {

   long callno;         /* caller number */

   char nbbs;           /* number of message bases */

   long nmess;          /* total messages in system */

   char ndrives;        /* number of drives online */

   char ndirect;        /* number of download directories */

   char subdir [20][9]; /* names of download directories */

   int pwnum;           /* size of password file */

   int mconf[65];       /* current number of messages allowed in each base */

   int cmess[65];       /* next message number  in each base */

   int nconf[65];       /* max number of messages in each base */

   int hmess[65];       /* high message on message base */

   char conf[65][41];   /* names of message bases */

   char textcolor;

   char backcolor;

   char drvlist[9];     /* drive search order */

   char defdir[37];     /* default directory */

   long flags;          /* various system flags (saved command options) */

                        /* Bit:

                           0 = spare

                           1 = chat mode on/off

                           2 = log to disk on/off

                           3 = guest allowed

                           4 = accounting on/off

                           5 = new user account number

                           6 = spare

                           7 = color monitor

                           8 = survey at new user logon

                           9 = email deleted after each user

                           10 = message to sysop as Email

                           11 = Uploads to sysop only

                           12 = Logon bulletins on/off

                           13 = Credit for upload time

                           14-31 spare

                        */         

   int counters[10];    /* various system counters */

                        /* 0 = UL/DL ratio

                           1 = user timeout in 1/60 seconds 

                           2 = Fmail auto delete in days

                           3 = FNET default message base */

   long fnum;           /* number of next download file */

   char expandc[6];

} config;



struct pword {

   int  rec;          /* record number in pas.dat */

   char id[13];       /* password */

   char name[31];    

   char phone[13];

   int  age;

   char lfeed;        /* line feeds on/off */

   int  cls;          /* computer type */

   int  calls;        /* number of calls */

   char last[3];      /* last call date */

   char first[3];     /* first call date */

   int  dl;           /* number of downloads */

   int  up;           /* uploads */

   int  mess;         /* messages sent */

   int  dbase;        /* data base files read */

   int  ubase;        /* data base files uploaded */

   int  mail;         /* Email messages sent */

   int  access;       /* access level for download and doors */

   int  dbaccess;     /* data base access level */

   long priv;         /* privilege bitmap */

   long rbase1,rbase2;/* read message bases bitmap*/

   long ebase1,ebase2;/* enter message bases bitmap */

   long funct;        /* commands bitmap */

   long usr;          /* usr functions bitmap */

   int  dtime;        /* daily time limit remaining at beginning of call*/

   int  climit;       /* daily call limit */

   int  dcalls;       /* daily calls remaining */

   int  tilim;        /* daily time limit */

   int  ctlim;        /* call time limit */

   int  ulim;         /* upload limit */

   int  dlim;         /* download limit */

   int  dbulim;       /* database upload limit */

   int  dbdlim;       /* database read limit */

   int  mailim;       /* Email limit */

   int  meslim;       /* enter message limit */

   char accnum[10];   /* account number */

   int  himess[65];   /* high message read counters */

   int  moncon;       /* month connect time */

   int  dai_up;       /* daily counters */

   int  dai_dn;

   int  dai_mes;

   int  dai_mai;

   int  dai_dbu;

   int  dai_dbd;

   int msg_delay;     /* continuous scroll delay time */

   long fbase;        /* bitmap of allowed dl directories */

   long ufbase;       /* user set bitmap of Scan ALL directories */

   long urbase1,urbase2; /* user set bitmap of READ ALL NEW messages bases */

   unsigned char arclim;

   char street[41];

   char city[21];

   char state[3];

   char zip[11];

   unsigned char fnetlim;

   unsigned char dai_fnet;

   unsigned char fnet_level;

   char last_file[3];

   unsigned char lines;

   char expand[3];

} user;



main(argc, argv) int argc; char *argv[];



{



    register FILE *fp;

    int begtime, endtime, curtime, hardcopy, bell, print, chatbell;

    int local, device, test, rings, printer, ignore, lock;

    char lastchar;

    int maxrings;

    register int n, x, y, fd, p;

    char c, buf[85], beghour[3], begmin[3], endhour[3], endmin[3];

    char end[3], command[81];

    time_t tnum;

    tm_t *ts;

    long cc, callno;



    while(Bconstat(1) == -1) {

        Bconin(1);

    }



    hardcopy = printer = ignore = lock = lastchar = 0;

    end[0] = '\r'; end[1] = '\n'; end [2] = 0;

    bell = 1;



    if (argc > 1) {



        time(&tnum);

	ts = localtime(&tnum);



        maxrings = atoi(argv[6]);



        fd = Fopen("forem.dat", 0);



        Fread(fd, (long) sizeof(config), &config);



        Fread(fd, (long) sizeof(user), &user);



        Fclose(fd);



        if (atoi(argv[5])) {



            if ((fd = Fopen("chat.usr", 0)) > -1) {

                Fread(fd, (long) sizeof(callno), &callno);

                Fclose(fd);

            }



            else

                callno = -1L;



            Fdelete("chat.usr");

            fd = Fcreate("chat.usr", 0);

            Fwrite(fd, (long) sizeof(config.callno), &config.callno);

            Fclose(fd);



            if (callno == config.callno && user.access < atoi(argv[3])) {

                    write_line("\r\nThe Sysop is unavailable at this time.  Try leaving a message...\r\n\r\n", 1);

                    exit(1);

            }



        }



        if (user.access < atoi(argv[3])) {



            beghour[0] = argv[1][0]; beghour[1] = argv[1][1]; beghour[2] = 0;

            begmin[0] = argv[1][2]; begmin[1] = argv[1][3]; begmin[2] = 0;

            endhour[0] = argv[2][0]; endhour[1] = argv[2][1]; endhour[2] = 0;

            endmin[0] = argv[2][2]; endmin[1] = argv[2][3]; endmin[2] = 0;



            begtime = atoi(beghour) * 60;

            begtime += atoi(begmin);



            endtime = atoi(endhour) * 60;

            endtime += atoi(endmin);



            test = 1;



            curtime = ((ts->tm_hour * 60) + ts->tm_min);



            if (curtime > begtime && curtime < endtime)

                test = 0;



            /* The following two tests deal with a time limit that spreads from

               PM to AM, ie chat off from 2300 (11PM) to 0400 (4AM) */



            if (begtime > endtime && curtime < endtime)

                test = 0;



            if (begtime > endtime && curtime > begtime && curtime > endtime)

                test = 0;



            if (!test) {

                write_line("\r\nThe Sysop is unavailable at this time.  Try leaving a message...\r\n\r\n", 1);

                exit(1);

            }

        }



        write_line("\r\nThe SysOp is being paged...  Press any key to abort...", 1);



        device = chatbell = 1;



        if (user.access < atoi(argv[4]))

            rings = maxrings;

        else

            rings = (maxrings * 10) + 1;



        for(x=0;x<rings;x++) {



            if (chatbell)

                Dosound(noise);



            device = 0;



            for(y=0;y<10000;y++) {

                if (cd_check() == 0)

                    exit(1);

                if (Bconstat(1) == -1) {

                    Bconin(1);

                    device = 1;

                    break;

                }



                if (Bconstat(2) == -1) {

                    c = Bconin(2);

                    if (c == 27) {

                        device = 2;

                        break;

                    }

                    else {

                        chatbell = 0;

                        continue;

                    }

                }

            }



            if (device > 0)

                break;

        }



        if (device < 2) {

            write_line("\r\n\r\nAborting...  The SysOp must not be around.  Try a message...\r\n\r\n", 1);

            exit(1);

        }



    }



    local = 1;

    buf[0] = 0;

    n = 0;



    write_line("\r\n\r\nSysOp Online...\r\n\r\n", 1);



    for(;;) {



        if (cd_check() == 0) {

            if (hardcopy) {

                Fwrite(fd, (long) strlen(buf), buf);

                Fwrite(fd, (long) strlen(end), end);

                Fclose(fd);

            }



            if (printer) {

                fputs(buf, fp);

                fputs(end, fp);

                fclose(fp);

            }



            exit(1);

        }



        print = 1;



        if (Bconstat(local) == 0) {

                if (Bconstat(2) == -1) {

                    cc = Bconin(2);

                    c = cc; /* take the integer part of the long input */

                    device = 2;

                }

                else

                    continue;

        }



        else {

                c = Bconin(local); 

                device = 1;

        }



        if (ignore && device == 2 && !lock) {

            lock = 1;

        }



        if (ignore && device == 2 && c == 13 && lastchar == 13 && lock) {

            lock = 0;

            /* if two consecutive returns, turn the lock off */

        }



        if (device == 2 && cc == 0x230000L) {

            write_line("\r\n\r\nHangup Requested...", local);

            Ongibit(0x10);

            while(cd_check()) {

                if (Bconstat(2) == -1) {

                    Bconin(2);

                    write_line("\r\nHangup Aborted!\r\n\r\n", local);

                    break;

                }

            }

            Offgibit(0x0F);

            continue;

        }



        if (device == 2 && cc == 0x410000L && !ignore) {

            ignore = 1;

            lock = 0;

            Bconout(2, 7);

            continue;

        }



        if (device == 2 && cc == 0x410000L && ignore) {

            ignore = 0;

            continue;

        }



        if (device == 2 && cc == 0x400000L) {

            write_line("\r\n\r\nSysOp is exiting chat.  Please wait...", 1);

            write_line("\r\n", 2);

            if (hardcopy) {

                Fwrite(fd, (long) strlen(buf), buf);

                Fwrite(fd, (long) strlen(end), end);

            }

            if (printer) {

                fputs(buf, fp);

                fputs(end, fp);

                fflush(fp);

            }

            for (;;) {

                write_line("\r\nFile: ", 2);

                get_line(command, 73, 2);

                if (command[0] == 'e' && command[1] == 'x' && command[2] == 'i'

                  && command[3] == 't') {

                    Bconout(1, 13);

                    Bconout(1, 10);

                    write_line("\r\nSysOp Online...\r\n\r\n", 1);

                    break;

                }

                Bconout(1, 13);

                Bconout(1, 10);

                write_line("\r\n", 1);

                show_file(command);

            }

            buf[0] = n = 0;

            while(Bconstat(1) == -1) {  /* eat what they typed while offline */

                Bconin(1);

            }

            continue;

        }



        if (device == 2 && cc == 0x3F0000L) {

            write_line("\r\n\r\nSysOp is exiting chat.  Please wait...", 1);

            write_line("\r\n", 2);

            if (hardcopy) {

                Fwrite(fd, (long) strlen(buf), buf);

                Fwrite(fd, (long) strlen(end), end);

            }

            if (printer) {

                fputs(buf, fp);

                fputs(end, fp);

                fflush(fp);

            }

            for (;;) {

                write_line("\r\nCommand: ", 2);

                get_line(command, 70, 2);

                if (command[0] == 'e' && command[1] == 'x' && command[2] == 'i'

                  && command[3] == 't') {

                    Bconout(1, 13);

                    Bconout(1, 10);

                    write_line("\r\nSysOp Online...\r\n\r\n", 1);

                    break;

                }

                write_line("\r\n", 2);

                system(command);

            }

            buf[0] = n = 0;

            while(Bconstat(1) == -1) {  /* eat what they typed while offline */

                Bconin(1);

            }

            continue; 

       }



        if (device == 2 && cc == 0x3E0000L && !printer) {

            if (Cprnos()) {

                if ((fp = fopen("prn:", "wb")) != NULL)

                    printer = 1;

            }



            if (printer)

                Bconout(2, 7);



            continue;

        }



        if (device == 2 && cc == 0x3D0000L && !hardcopy) {

            Fdelete("chat.log");

            Bconout(2, 7);

        }



        if (device == 2 && cc == 0x3B0000L && !hardcopy) {

            if ((fd = Fopen("chat.log", 2)) > -1) {

                Fseek(Fseek(0L, fd, 2), fd, 0);

            }

            else {

                fd = Fcreate("chat.log", 0);

            }



            hardcopy = 1;

            Bconout(2, 7);

            continue;

        }        



        if (device == 2 && cc == 0x3E0000L && printer) {

            fputs(buf, fp);

            fputs(end, fp);

            fclose(fp);

            printer = 0;

            continue;

        }



        if (device == 2 && cc == 0x3B0000L && hardcopy) {

            Fwrite(fd, (long) strlen(buf), buf);

            Fwrite(fd, (long) strlen(end), end);

            Fclose(fd);

            hardcopy = 0;

            continue;

        }



        if (device == 2 && cc == 0x3C0000L && !bell) {

            bell = 1;

            Bconout(2, 7);

            continue;

        }



        if (device == 2 && cc == 0x3C0000L && bell) {

            bell = 0;

            continue;

        }



        if (ignore && device == 1 && lock)

            continue; /* if lock is on, we ignore input from the modem */



        if (c == '\b' || c == 127) {

            if (n > 0) {

                buf[n--] = 0;

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                Bconout(2, 8);

                Bconout(2, 32);

                Bconout(2, 8);

                continue;

            }

            else

                continue;

        }



        if (c == 7) {

                Bconout(local, c);            

                if (bell)

                    Bconout(2, c);

                continue;

            }



        if (c == 12) {

                Bconout(local, 12);

                Bconout(5, 12);

                n = 0;

                buf[n] = 0;

                Bconout(2, 13);

                Bconout(2, 10);

                continue;

        }



        if (c == 4) { /* Delete Word */



            n--; /* move off of null so that next routine won't be messed up */



            while (n > -1 && buf[n] == ' ') {

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                Bconout(2, 8);

                Bconout(2, 32);

                Bconout(2, 8);

                n--;

            }



            while (n > -1 && buf[n] != ' ') {

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                Bconout(2, 8);

                Bconout(2, 32);

                Bconout(2, 8);

                n--;

            } 



            buf[++n] = 0;

            continue;



        }



        if (c == 24) {

            for(;;) {

                if (!Bcostat(1) || !Bcostat(2))

                    continue;

                if (!n)

                    break;

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                Bconout(2, 8);

                Bconout(2, 32);

                Bconout(2, 8);

                n--;

            }

            buf[n] = 0;

            continue;

        }



        if (c == 27 && device == 2) {

            Bconout(local, 13);

            Bconout(2, 13);

            Bconout(local, 10);

            Bconout(2, 10);

            if (hardcopy) {

                Fwrite(fd, (long) strlen(buf), buf);

                Fwrite(fd, (long) strlen(end), end);

                Fclose(fd);

            }

            if (printer) {

                fputs(buf, fp);

                fputs(end, fp);

                fclose(fp);

            }

            exit(0);

        }



        if (c == 13) {



            if (printer) {

                fputs(buf, fp);

                fputs(end, fp);

                fflush(fp);

            }



            if (hardcopy) {

                Fwrite(fd, (long) strlen(buf), buf);

                Fwrite(fd, (long) strlen(end), end);

            }



            Bconout(local, c);

            Bconout(2, c);



            lastchar = c;

            n = 0;

            buf[n] = 0;

            Bconout(local, 10);

            Bconout(2, 10);



            continue;



        }



        if (c < 32 || c > 126)

            print = 0;



        if (print) {



            Bconout(local, c);

            Bconout(2, c);



            lastchar = c; /* record last character */



            buf[n++] = c;

            buf[n] = 0;



            if (n==79) {

                for (x=79;x>-1;x--) {

                    if (buf[x] == ' ')

                        break;

                }



                if (printer) {

                    if (buf[x] == ' ') {

                        fputs(buf, fp);

                        fputs(end, fp);

                        fflush(fp);

                    }



                    else {

                        fputs(buf, fp);

                        fflush(fp);

                    }

                }



                if (hardcopy) {



                    if (buf[x] == ' ') {

                        Fwrite(fd, (long) x, buf);

                        Fwrite(fd, (long) strlen(end), end);

                    }

    

                    else {

                        Fwrite(fd, (long) strlen(buf), buf);

                    }



                }



                if (buf[x] == ' ') {

                    y = x;  

                    p = 0;



                    while(y < 80) {

                        y++;

                        buf[p] = buf[y];

                        p++;

                        buf[p] = 0;

                    }



                    for(;x<79;++x) {

                        Bconout(local, 8);

                        Bconout(local, 32);

                        Bconout(local, 8);

                        Bconout(2, 8);

                        Bconout(2, 32);

                        Bconout(2, 8);

                    }



                    y = 0;



                    Bconout(local, 13);

                    Bconout(2, 13);

                    Bconout(local, 10);

                    Bconout(2, 10);



                    while(buf[y] != 0) {

                        Bconout(local, buf[y]);

                        Bconout(2, buf[y]);

                        y++;

                    }



                    n = y;



                }



                else {

                    Bconout(local, 13);

                    Bconout(2, 13);

                    Bconout(local, 10);

                    Bconout(2, 10);

                    n = 0;

                    buf[n] = 0;

                 }



            }



        }



    }



    exit(0);



}



show_file(output) char *output;



{

    int fd, n;



    if ((fd = Fopen(output, 0)) < 0)    

        return(0);



    while((n = Fread(fd, 79L, output)) > 0) {

        output[n] = 0;

        if (!write_line(output, 1)) {

            Fclose(fd);

            return(2);

        }

    }



    Fclose(fd);



    return(1);



}



write_line(s, local) char *s; int local;



{

    int length, slength;

    char c;



    length = strlen(s);

    slength = 0;



    while (slength < length) {

        if (local == 1 && cd_check() == 0)

            exit(1);

        if (Bconstat(local) == -1 || Bconstat(2) == -1) {

            if (local == 1 && Bconstat(2) == -1)

                c = Bconin(2);

            if (Bconstat(local) == -1)

                c = Bconin(local);

            if (c == 'q' || c == 'Q' || c == 3)

                return(0);

            if (c == 19) {

                while (Bconstat(local) == 0 && Bconstat(2) == 0) {

                    if (local == 1 && cd_check() == 0)

                        exit(1);

                }



                if (Bconstat(local) == -1)

                    c = Bconin(local);

                else

                    c = Bconin(2);



                if (c == 3 || c == 'q' || c == 'Q')

                    return(0);

            }



        }



        if (Bcostat(local) == -1) {

            Bconout(local, *s);

            if (local == 1)

                Bconout(2, *s);

            slength++;

            *s++;

        }

    }

}



get_line(s, length, local) char *s; int length, local;



{



    int slength;



    slength = 1;

    length += 2;



    while (slength < length) {



        if (local == 1 && cd_check() == 0)

            exit(1);



        if (Bconstat(local) == 0) {

            if (local == 1 && Bconstat(2) == -1)

                *s = Bconin(2);

            else

                continue;

        }



        else

            *s = Bconin(local); 



        if (*s < 32 && *s !=13 && *s !=8)

            continue;

        if (*s == '\b' || *s == 127) {

            if (slength > 1) {

                slength--;

                *s--;

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                if (local == 1) {

                    Bconout(2, 8);

                    Bconout(2, 32);

                    Bconout(2, 8);

                }

                continue;

            }

            else

                continue;

        }

        if (slength == (length - 1) && *s != '\r')

            continue;

        if (local == 1)

            Bconout(2, *s);

        Bconout(local, *s);

        if (*s == '\r') {

            Bconout(local, '\n');

            if (local == 1)

                Bconout(2, '\n');

            *s = 0;

            return;

        }    

        slength++;

        *s++;



    }



    *s = 0;



}



int cd_check()



{



char *gpip;

long stack;

char test;



   gpip=(char *)0xFFFFFA01L;

   stack=Super(0L);

   test= *gpip;    

   Super(stack);

   if (test & 2) 

      return(0); /* set this back to 0 */

   else

      return(1);

}

