#include <stdio.h>

#include <osbind.h>

#include <time.h>

#include <bios.h>

#include <ctype.h>



struct {

	char white[31];

	char black[31];

	char turn[6];

} members;



struct {

	char square[65];

	int move;

	time_t move_date;

	char last_move[6];

	int d_pawn_move;

	int check;

	int wpoints;

	int bpoints;

	int draw;

	int wking, bking;

	int wqrook, wkrook, bqrook, bkrook;

	int wdraw, bdraw;



} board;



struct {

	char name[31];

	char alias[31];

	int games;

	int wins;

	int losses;

	int draws;

} plr;



char hline, vline, ltop, lbot, rtop, rbot;



main(argc, argv) int argc; char *argv[];



{



	register FILE *fp, *op;

	register int n;



	int local, maxgame, nogame, fd, bp, maxdays, gameno;

	int sqr, count, status, delete;

	int l, bd, size;

	char name[31], bakput[50], option[20];

	long recpos;



	char buf[83], alias[10], first[31], file[41], output[160];

	char history[41], view[6], ans, clear[10];

	char hiscore[41], menu[41], game[10], revon[10], revoff[10];



	recpos = 0;



	if (argc > 1) {

		if (pnmatch(argv[1], "l", 1) || pnmatch(argv[1], "L", 1))

			local = 2;

	}



	else

		local = 1;



	if ((fp = fopen("chess.dat", "rb")) == NULL) {

		exit(1);

	}



	fgets(file, 41, fp);

	strip_string(file);

	sprintf(buf, "%sdorinfo1.def", file);

	if ((op = fopen(buf, "rb")) == NULL)

		exit(1);

	for (n=1; n<7; n++) {

		fgets(buf, 80, op);

	}

	fgets(buf, 80, op);

	strip_string(buf);

	strcpy(first, buf);

	fgets(buf, 80, op);

	strip_string(buf);

	if (buf[0] != 0)

		sprintf(name, "%s %s", first, buf);

	else

		strcpy(name, first);

	fclose(op);



	fgets(file, 41, fp);

	strip_string(file);

	fgets(buf, 5, fp);

	nogame = atoi(buf);

	fgets(buf, 5, fp);

	maxgame = atoi(buf);

	fgets(history, 41, fp);

	strip_string(history);

	fgets(buf, 5, fp);

	maxdays = atoi(buf);

	fgets(menu, 41, fp);

	strip_string(menu);

	fgets(hiscore, 41, fp);

	strip_string(hiscore);



	fclose(fp);



	sprintf(alias, name);



	sprintf(output, "%stccpem.lst", file);



	if ((op = fopen(output, "rb")) != NULL) {



		status = 0;



                if (local == 1) {



        		while(status == 0) {



	        		write_line("\r\n\r\nPlease select an emulation mode:\r\n\r\n", local);



		        	fseek(op, 0L, 0);

			        fgets(buf, 6, op);

			        count = atoi(buf) + 1;

        			for (n=1; n<count; n++) {

	        			fgets(buf, 40, op);

		        		strip_string(buf);

			        	sprintf(output, "%d: %s\r\n", n, buf);

				        write_line(output, local);

        				fgets(buf, 40, op);

	        			fgets(buf, 40, op);

		        		fgets(buf, 40, op);

                                        fgets(buf, 40, op);

        			}



	        		write_line("\r\nSelection (Q=Quit): ", local);

		        	ans = buf[0] = get_char(local);

			        buf[1] = 0;

        			write_line(buf, local);

	        		if (ans == 'q' || ans == 'Q') {

		        		write_line("\r\n\r\n", local);

			        	exit(0);

        			}

	        		if (atoi(buf) > 0 && atoi(buf) < count)

		        		status = 1;

			        else

				        write_line("\r\n\r\n", local);

		        }

                }



                else

                    buf[0] = '1'; buf[1] = 0;

	}



	if (op == NULL)

		exit(1);



	count = atoi(buf) + 1;

	fseek(op, 0L, 0);

	fgets(output, 40, op);

	for (n=1; n<count; n++) {

		fgets(output, 40, op);

		fgets(clear, 20, op);

		strip_string(clear);

		fgets(revon, 20, op);

		strip_string(revon);

		fgets(revoff, 20, op);

		strip_string(revoff);

                fgets(buf, 10, op);

                strip_string(buf);

	}



	fclose(op);



        if (buf[0] == 0)

            sprintf(buf, "|=====");



        vline = buf[0];

        hline = buf[1];

        ltop =  buf[2];

        rtop =  buf[3];

        lbot =  buf[4];

        rbot =  buf[5];



	clear_screen(clear, local);



        for(;;) {

            output[0] = 0;

            if (local == 2)

                write_line("f", local);

            clear_screen(clear, local);

            write_line("\r\n\r\n\r\n\r\n\r\n\r\n", local);

            size = 39 - (22 / 2);

            for(count=0;count<size;count++)

                strcat(output, " ");

            write_line(output, local);

            rev_on(revon, local);

            write_line("                      ", local);

            rev_off(revoff, local);

            write_line("\r\n", local);

            write_line(output, local);

            rev_on(revon, local);

            write_line("   ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("TCCP Game Editor", local);

            else

                write_line("b2TCCP Game Editorb3", local);

            rev_on(revon, local);

            write_line("   ", local);

            rev_off(revoff, local);

            write_line("\r\n", local);

            write_line(output, local);

            rev_on(revon, local);

            write_line("                      ", local);

            rev_off(revoff, local);

            write_line("\r\n", local);

            write_line(output, local);

            rev_on(revon, local);

            write_line(" ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("G", local);

            else

                write_line("b1Gb3", local);

            rev_on(revon, local);

            write_line(" Edit Game ------ ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("G", local);

            else

                write_line("b1Gb3", local);

            rev_on(revon, local);

            write_line(" ", local);

            rev_off(revoff, local);

            write_line("\r\n", local);

            write_line(output, local);

            rev_on(revon, local);

            write_line(" ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("K", local);

            else

                write_line("b1Kb3", local);

            rev_on(revon, local);

            write_line(" Kill Game ------ ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("K", local);

            else

                write_line("b1Kb3", local);

            rev_on(revon, local);

            write_line(" ", local);

            rev_off(revoff, local);

            write_line("\r\n", local);



            write_line(output, local);

            rev_on(revon, local);

            write_line(" ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("L", local);

            else

                write_line("b1Lb3", local);

            rev_on(revon, local);

            write_line(" List Players --- ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("L", local);

            else

                write_line("b1Lb3", local);

            rev_on(revon, local);

            write_line(" ", local);

            rev_off(revoff, local);

            write_line("\r\n", local);

            write_line(output, local);

            rev_on(revon, local);

            write_line(" ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("P", local);

            else

                write_line("b1Pb3", local);

            rev_on(revon, local);

            write_line(" Edit Player ---- ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("P", local);

            else

                write_line("b1Pb3", local);

            rev_on(revon, local);

            write_line(" ", local);

            rev_off(revoff, local);

            write_line("\r\n", local);

            write_line(output, local);

            rev_on(revon, local);

            write_line(" ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("Q", local);

            else

                write_line("b1Qb3", local);

            rev_on(revon, local);

            write_line(" Quit ----------- ", local);

            rev_off(revoff, local);

            if (local == 1)

                write_line("Q", local);

            else

                write_line("b1Qb3", local);

            rev_on(revon, local);

            write_line(" ", local);

            rev_off(revoff, local);

            write_line("\r\n", local);

            write_line(output, local);

            rev_on(revon, local);

            write_line("                      ", local);

            rev_off(revoff, local);

            write_line("\r\n\r\n", local);

            write_line(output, local);

            write_line("   Selection: ", local);

            if (local == 2)

                write_line("e", local);

            get_line(output, 10, local);

            if (output[0] == 'Q' || output[0] == 'q') {

                clear_screen(clear, local);

                break;

            }

            write_line("\r\n", local);



            clear_screen(clear, local);



            if (output[0] == 'L' || output[0] == 'l') {

                sprintf(output, hiscore);

                show_file(output, local);

                write_line("\r\nPress <return> to continue...", local);

                get_char(local);

                continue;

            }



            if (output[0] == 'K' || output[0] == 'k') {



        	sprintf(output, "%stccpgame.lst", file);



	        fd = Fopen(output, 2);



	        for (;;) {



		        write_line("Enter game you wish to kill (<return>=Exit): ", local);



		        get_line(output, 5, local);



		        if (output[0] == 'Q' || output[0] == 'q' || output[0] == 0)

			        break;



		        gameno = atoi(output);



		        Fseek((68L * (long) (gameno - 1)), fd, 0);

	

		        Fread(fd, (long) sizeof(members), &members);	



		        write_line("\r\nKill game between: ", local);



		        write_line(members.white, local);



		        write_line(" & ", local);



		        write_line(members.black, local);



		        write_line("? ", local);



		        output[0] = get_char(local);



		        if (output[0] == 'Y' || output[0] == 'y') {



                                write_line("Yes\r\n", local);



                                sprintf(output, "%stccpplr.lst", file);



                                bp = Fopen(output, local);



                		Fseek(0L, bp, 0);



                                recpos = 0;



		                while((Fread(bp, (long) sizeof(plr), &plr)) > 0) {

			            if (pnmatch(plr.alias, members.white, 0)) {

			    	        status = 1;

				        break;

        			    }



			            recpos = Fseek(0L, bp, 1);



                                }



                                Fseek(recpos, bp, 0);



                                plr.games--;



                                if (!pnmatch(members.white, "No_Player", 0))

                                    Fwrite(bp, (long) sizeof(plr), &plr);    



                		Fseek(0L, bp, 0);



                                recpos = 0;



		                while((Fread(bp, (long) sizeof(plr), &plr)) > 0) {

			            if (pnmatch(plr.alias, members.black, 0)) {

			    	        status = 1;

				        break;

        			    }



			            recpos = Fseek(0L, bp, 1);



                                }



                                Fseek(recpos, bp, 0);



                                plr.games--;



                                if (!pnmatch(members.black, "No_Player", 0))

                                    Fwrite(bp, (long) sizeof(plr), &plr);    



                                Fclose(bp);



			        Fseek((68L * (long) (gameno - 1)), fd, 0);

	

			        strcpy(members.white, "No_Player");

			        strcpy(members.black, "No_Player");

			        strcpy(members.turn, "White");



			        Fwrite(fd, (long) sizeof(members), &members);



                                create_menu(menu, output, file);



		        }



                        else

                            write_line("No\r\n", local);



	        }



        	Fclose(fd);



                write_line("\r\n", local);



                continue;



            }



            if (output[0] == 'G' || output[0] == 'g') {



    	        for(;;) {



		    write_line("Edit which game (?=List, <return>=Exit): ", local);

        	    get_line(game, 4, local);

	            write_line("\r\n", local);



                    if (game[0] == '?') {



        		    sprintf(output, "%stccpgame.lst", file);

		            fd = Fopen(output, 0);



                            count = 1;



		            while(Fread(fd, (long) sizeof(members), &members) > 0) {

                                sprintf(output, "%3d:  %-30s  %-30s\r\n", count, members.white, members.black);

                                if (!pnmatch(members.white, "No_Player", 0) && !pnmatch(members.black, "No_Player", 0))

                                    write_line(output, local);

                                count++;

                            }



                            Fclose(fd);



                            write_line("\r\n", local);



                            continue;

                    }



	            gameno = atoi(game);



		    if (gameno < 1)

			break;



		    sprintf(output, "%stccpgame.lst", file);



		    fd = Fopen(output, 2);



		    Fseek(0L, fd, 0);



		    Fseek(((long) sizeof(members) * (long) (gameno - 1)), fd, 0);



		    Fread(fd, (long) sizeof(members), &members);	



		    sprintf(output, "%stccpbrd.%d", file, gameno);



		    if ((bp = Fopen(output, 2)) < 0)

			    continue;



		    Fread(bp, (long) sizeof(board), &board);



		    Fseek(0L, bp, 0);



		    display_board(bp, output, local, gameno, revon, revoff, members.turn, members.white, members.black, alias, members.turn, maxdays);



		    for (;;) {



			    write_line("\r\nSelection (<return>=Redisplay Board, ?=Help, Q=Quit): ", local);

			    get_line(output, 10, local);



                            if (output[0] == 0) {

        			display_board(bp, output, local, gameno, revon, revoff, members.turn, members.white, members.black, alias, members.turn, maxdays);

                                continue;

                            }



			    if (output[0] == 'q' || output[0] == 'Q') {

                                write_line("\r\n", local);

				break;

                            }



			    for (n=0;n<strlen(output);n++)

				output[n] = toupper(output[n]);



			    if (output[0] == '?') {

				write_line("\r\nBlack ........ Change Black's Name\r\n", local);

				write_line("BPoints ...... Change Black Points\r\n", local);

				write_line("Check ........ Toggle Check Status\r\n", local);

				write_line("Clear ........ Clear Game Board\r\n", local);

				write_line("Configure .... Alter Game Board\r\n", local);

				write_line("Draw ......... Change Draw Status\r\n", local);

                                write_line("Move ......... Alter Move No\r\n", local);

				write_line("Time ......... Update Time Left\r\n", local);

				write_line("Turn ......... Toggle Turn\r\n", local);

				write_line("White ........ Change White's Name\r\n", local);

				write_line("WPoints ...... Change White Points\r\n", local);

				continue;

			    }



			    if (pnmatch("DPAWN", output, 1)) {

				sprintf(output, "\r\nDouble Pawn Move = %d, New value: ", board.d_pawn_move);

				write_line(output, local);

				get_line(game, 5, local);

				board.d_pawn_move = atoi(game);

			    }



			    if (pnmatch("DRAW", output, 1)) {

                                write_line("\r\n0 = No Draw Offered, 1 = Draw offered, 2 = Draw refused\r\n", local);

				sprintf(output, "\r\nDraw = %d, New value: ", board.draw);

				write_line(output, local);

				get_line(game, 4, local);

				board.draw = atoi(game);

			    }



			    if (pnmatch("BPOINTS", output, 1)) {

				write_line("\r\nEnter new black point total: ", local);

				get_line(game, 2, local);

				board.bpoints = atoi(game);

			    }



			    if (pnmatch("WPOINTS", output, 1)) {

				write_line("\r\nEnter new white point total: ", local);

				get_line(game, 2, local);

				board.wpoints = atoi(game);

			    }



                            if (pnmatch("MOVE", output, 1)) {

                            write_line("\r\nEnter new move number: ", local);

                            get_line(game, 2, local);

                            board.move = atoi(game);

                            }



			    if (pnmatch("TIME", output, 1)) {



				write_line("\r\nAdd how many days to move time? ", local);



				get_line(game, 3, local);



				write_line("\r\n\r\n", local);

	

				board.move_date += (86400L * (long) atoi(game));



			    }



			    if (pnmatch("CONFIGURE", output, 1)) {



				for (;;) {

					write_line("\r\nSquare (<return>=Exit): ", local);

					get_line(game, 2, local);



					if (game[0] == 0)

						break;



					game[0] = toupper(game[0]);



					sqr = convert_coord(game[0], game[1]);



					if (sqr < 0 || sqr > 63)

						continue;



                                        write_line("\r\nWhite Pieces = KQRBNP, Black Pieces = kqrbnp, Empty Square = <SPACE>\r\n\r\n", local);

					write_line("Piece (<return> = Exit): ", local);

					get_line(game, 1, local);



                                        if (game[0] == 0)

                                            break;



					board.square[sqr] = game[0];



				}

			    }

			

			    if (pnmatch("CLEAR", output, 1)) {

				for (sqr=0;sqr<64;sqr++) {

					board.square[sqr] = ' ';

				}

			    }



			    if (pnmatch("CHECK", output, 1)) {

				if (board.check == 0)

					board.check = 1;

				else

					board.check = 0;

			    }



			    if (pnmatch("WHITE", output, 1)) {

				write_line("Enter white player: ", local);

				get_line(members.white, 30, local);

				write_line("\r\n", local);

			    }



			    if (pnmatch("BLACK", output, 1)) {

				write_line("Enter black player: ", local);

				get_line(members.black, 30, local);

				write_line("\r\n", local);

			    }



			    if (pnmatch("TURN", output, 1)) {

				if (members.turn[0] == 'W')

					sprintf(members.turn, "Black");

				else

					sprintf(members.turn, "White");

			    }



			    Fseek(0L, fd, 0);



			    Fseek(((long) sizeof(members) * (long) (gameno - 1)), fd, 0);



			    Fwrite(fd, (long) sizeof(members), &members);	



			    Fseek(0L, bp, 0);



			    Fwrite(bp, (long) sizeof(board), &board);



			    if (pnmatch(output, "CONVERT", 0))

				printf("%d --> %d\n", board.wdraw, board.bdraw);



			    Fseek(0L, bp, 0);

		

			    display_board(bp, output, local, gameno, revon, revoff, members.turn, members.white, members.black, alias, members.turn, maxdays);



		    }



		    Fclose(fd);

		    Fclose(bp);



	        }	



                continue;



            }



            if (output[0] == 'P' || output[0] == 'p') {



                delete = 0;



	        sprintf(output, "%stccpplr.lst", file);



        	fd = Fopen(output, 2);



	        for (;;) {



		    write_line("Type ALIAS of player to edit (<return>=Exit): ", local);



		    get_line(name, 30, local);



		    if (name[0] == 'Q' || name[0] == 'q' || name[0] == 0)

			    break;



		    recpos = status = 0;



		    Fseek(0L, fd, 0);



		    while((Fread(fd, (long) sizeof(plr), &plr)) > 0) {

			    if (pnmatch(plr.alias, name, 0)) {

			    	status = 1;

				break;

			    }



			    recpos = Fseek(0L, fd, 1);



		    }



		    if (!status) {

			Fseek(0L, fd, 0);

			write_line("\r\nNot found!\r\n\r\n", local);

			continue;

		    }



		    option[0] = 0;



		    while (option[0] != 'q' && option[0] != 'Q') {



                        write_line("\r\n", local);

                        sprintf(output, "Name:    %s\r\n", plr.name);

                        write_line(output, local);

                        sprintf(output, "Alias:   %s\r\n", plr.alias);

                        write_line(output, local);

                        sprintf(output, "Games:   %d\r\n", plr.games);

                        write_line(output, local);

                        sprintf(output, "Wins:    %d\r\n", plr.wins);

                        write_line(output, local);

                        sprintf(output, "Losses:  %d\r\n", plr.losses);

                        write_line(output, local);

                        sprintf(output, "Draws:   %d\r\n\r\n", plr.draws);

                        write_line(output, local);

                        write_line("Command (?=List, Q=Quit): ", local);

			get_line(option, 20, local);



                        if (option[0] == 0)

                            option[0] == 'Q';



			for (l=0;l<strlen(option);l++)

				option[l] = toupper(option[l]);



                        if (option[0] == '?') {

                            write_line("\r\n", local);

                            write_line("ALIAS .......... Change Alias\r\n", local);

                            write_line("NAME ........... Change Name\r\n", local);

                            write_line("GAMES .......... Change No of Games\r\n", local);

                            write_line("WINS ........... Change Wins\r\n", local);

                            write_line("LOSSES ......... Change Losses\r\n", local);

                            write_line("DRAWS .......... Change Draws\r\n", local);

                            write_line("DELETE ......... Delete Player\r\n", local);

                            write_line("RESET .......... Set Wins, Losses, Draws = 0\r\n", local);

                            continue;

                        }



			if (pnmatch(option, "DELETE", 0)) {

                                write_line("\r\nDeleting...\r\n", local);

				Fclose(fd);

				sprintf(output, "%stccpplr.lst", file);

				sprintf(bakput, "%stccpplr.bak", file);

				Frename(0, output, bakput);

				fd = Fcreate(output, 0);

				bd = Fopen(bakput, 0);

				sprintf(name, plr.alias);

				while(Fread(bd, (long) sizeof(plr), &plr) > 0) {

					if (pnmatch(name, plr.alias, 0))

						continue;

					Fwrite(fd, (long) sizeof(plr), &plr);

				}

				Fclose(bd);

				Fdelete(bakput);

				delete = 1;

                                break;

		        }



			if (pnmatch(option, "RESET", 0)) {

                                write_line("Wins, Losses, Draws = 0\r\n", local);

				plr.wins = plr.losses = plr.draws = 0;

			}



			if (pnmatch(option, "NAME", 0)) {



				sprintf(output, "Name (%s): ", plr.name);



				write_line(output, local);



				get_line(plr.name, 30, local);



				write_line("\r\n", local);



			}



			if (pnmatch(option, "GAMES", 0)) {



				sprintf(output, "Games (%d): ", plr.games);



				write_line(output, local);



				get_line(name, 3, local);



				write_line("\r\n", local);



				plr.games = atoi(name);



			}



			if (pnmatch(option, "ALIAS", 0)) {



                                Fclose(fd);

                                write_line("\r\n", local);

                                change_alias(file, output, local, recpos, menu); 

                                sprintf(output, "%stccpplr.lst", file);

                                fd = Fopen(output, 2);

				write_line("\r\n", local);

			}



			if (pnmatch(option, "WINS", 0)) {



				sprintf(output, "Wins (%d): ", plr.wins);



				write_line(output, local);



				get_line(name, 5, local);



				write_line("\r\n", local);



				plr.wins = atoi(name);

			}



			if (pnmatch(option, "LOSSES", 0)) {



				sprintf(output, "Losses (%d): ", plr.losses);



				write_line(output, local);



				get_line(name, 5, local);



				write_line("\r\n", local);



				plr.losses = atoi(name);

			}



			if (pnmatch(option, "DRAWS", 0)) {



				sprintf(output, "Draws (%d): ", plr.draws);



				write_line(output, local);



				get_line(name, 5, local);



				write_line("\r\n", local);



				plr.draws = atoi(name);

			}





		    }



		    if (!delete) {



			Fseek(recpos, fd, 0);

			Fwrite(fd, (long) sizeof(plr), &plr);

		    }



                    write_line("\r\n", local);



		    if (delete) {

			delete = 0;

                    }



	        }



	        Fclose(fd);



                write_line("\r\nUpdating data files, please wait...", local);



                write_scores(hiscore, output, file);



                write_line("\r\n", local);



                continue;



            }



        }



    exit(0);

}



show_file(output, local)



char *output; int local;



{

    int fd, n;



    if ((fd = Fopen(output, 0)) < 0) {

        return(0);

    }



    while((n = Fread(fd, 159L, output)) > 0) {

        output[n] = 0;

        if (!write_line(output, local)) {

            Fclose(fd);

            return(2);

        }

    }



    Fclose(fd);



    return(1);



}



write_scores(hiscore, output, file) char *hiscore, *output, *file;



{



    int fd, bd, ceiling, floor, rank, status;



    struct {

    	    char name[31];

            char alias[31];

            int games;

            int wins;

            int losses;

            int draws;

    } plr;



    plr.name[0] = plr.alias[0] = plr.games = plr.wins = plr.losses = 0;

    plr.draws = 0;



    ceiling = 32767;

    rank = 0;

    status = 1;



    sprintf(output, "%stccpplr.lst", file);



    fd = Fopen(output, 2);



    Fdelete(hiscore);



    bd = Fcreate(hiscore, 0);



    sprintf(output, "\r\nRank  Name                                   Wins         Losses          Draws\r\n");



    Fwrite(bd, (long) strlen(output), output);



    sprintf(output, "===============================================================================\r\n");



    Fwrite(bd, (long) strlen(output), output);



    while(status) {



        status = 0;



        floor = -1;



        Fseek(0L, fd, 0);



	while((Fread(fd, (long) sizeof(plr), &plr)) > 0) {

            if (plr.wins < ceiling && plr.wins > floor)

                floor = plr.wins;

        }



        Fseek(0L, fd, 0);



        ceiling = floor;



        rank++;



	while((Fread(fd, (long) sizeof(plr), &plr)) > 0) {

            if (plr.wins == floor) {

                sprintf(output, "%3d   %-30s          %2d            %2d             %2d\r\n", rank, plr.alias, plr.wins, plr.losses, plr.draws);

                Fwrite(bd, (long) strlen(output), output);

                status = 1;

            }

        }

    }



    sprintf(output, "===============================================================================\r\n");



    Fwrite(bd, (long) strlen(output), output);



    Fclose(fd);

    Fclose(bd);



}



create_menu(menu, output, file) char *menu, *output, *file;



{



    int md, fd, n;



    struct game {

        char white[31];

        char black[31];

        char turn[6];

    } members;



    members.white[0] = 0;

    members.black[0] = 0;

    members.turn[0] = 0;

    n = 0;



    sprintf(output, "%stccpgame.lst", file);



    md = Fopen(output, 2);



    Fdelete(menu);



    fd = Fcreate(menu, 0);



    sprintf(output, "\r\n                  The Complete Chess Player Game History Menu\r\n");

    Fwrite(fd, (long) strlen(output), output);

    sprintf(output, "                  - - - - - - - - - - - - - - - - - - - - - -\r\n\r\n");

    Fwrite(fd, (long) strlen(output), output);

    sprintf(output, "Game    White                              Black\r\n");

    Fwrite(fd, (long) strlen(output), output);

    sprintf(output, "===============================================================================\r\n");

    Fwrite(fd, (long) strlen(output), output);



    while (Fread(md, (long) sizeof(members), &members) > 0) {

        n++;

        if (pnmatch(members.white, "No_Player", 0) || pnmatch(members.black, "No_Player", 0))

            continue;



        sprintf(output, "%3d     %-30s     %s\r\n", n, members.white, members.black);

        Fwrite(fd, (long) strlen(output), output);

    }



    sprintf(output, "===============================================================================\r\n");

    Fwrite(fd, (long) strlen(output), output);

    sprintf(output, "\r\n");

    Fwrite(fd, (long) strlen(output), output);



    Fclose(fd);

    Fclose(md);



}



display_board(fd, output, local, jgame, revon, revoff, turn, white, black, alias, view, maxdays)



int fd; char *output; int local, jgame; char *revon, *revoff, *turn;

char *white, *black, *alias, *view; int maxdays;



{



    char space[10];



    int n, i, box, rank, add, row, line;

    long daysleft, secs, hours, mins;

    time_t curdate;



    struct {

        char square[65];

        int move;

        time_t move_date;

        char last_move[6];

        int d_pawn_move;

        int check;

        int wpoints;

        int bpoints;

        int draw;

        int wking, bking;

        int wqrook, wkrook, bqrook, bkrook;

        int wdraw, bdraw;

    } board;



    board.square[0] = board.move = board.last_move[0] = 0;

    board.d_pawn_move = board.check = board.wpoints = board.bpoints = 0;

    board.draw = board.wking = board.bking = board.wqrook = 0;

    board.wkrook = board.bqrook = board.bkrook = board.move_date = 0;

    board.wdraw = board.bdraw = 0;



    line = 0;



    if (pnmatch(view, "White", 0)) {

        rank = 9;

        box = 63;

        add = 1;

        row = -8;

    }



    else {

        rank = 0;

        box = 0;

        add = -1;

        row = 8;

    }



    space[0] = 0;



    Fseek(0L, fd, 0);



    Fread(fd, (long) sizeof(board), &board);



    time(&curdate);



    daysleft = (board.move_date - curdate)/86400L;

    secs = (board.move_date - curdate) - (daysleft * 86400L);

    hours = secs / 3600;

    mins = (secs - (hours * 3600)) / 60;



    if (!write_line("\r\n", local))

        return(0);



    board_top(local);



    sprintf(output, "\r\n");



    if (!write_line(output, local))

        return(0);



    for(n=0;n<4;n++) {



        write_line(" ", local);



        v_line(local);



        for(i=0;i<4;i++) {

            rev_on(revon, local);

            if (!write_line("    ", local)) {

                rev_off(revoff, local);

                return(0);

            }

            rev_off(revoff, local);

            if (!write_line("    ", local))

                return(0);

        }



        v_line(local);



        line++;



        if (line == 1) {

            sprintf(output, "     Game No: %d", jgame);

            if (!write_line(output, local))

                return(0);

        }



        if (line == 9) {

            sprintf(output, "     Last Move: %s", board.last_move);

            if (!write_line(output, local))

                return(0);

        }



        if (!write_line("\r\n", local))

            return(0);



        rank -= add;

        sprintf(output, "%d", rank);

        if (!write_line(output, local))

            return(0);



        v_line(local);



        box += row;



        for(i=0;i<4;i++) {

            box += add;

            get_piece(space, board.square[box]);

            rev_on(revon, local);

            if (!write_line(space, local)) {

                rev_off(revoff, local);

                return(0);

            }

            box += add;

            get_piece(space, board.square[box]);

            rev_off(revoff, local);

            if (!write_line(space, local))

                return(0);

        }



        box += row;



        v_line(local);



        line++;



        if (line == 6) {

            sprintf(output, "     Move No:   %d", board.move);

            if (!write_line(output, local))

                return(0);

        }



        if (line == 14) {

            if (pnmatch(turn, "White", 0) && pnmatch(white, alias, 0) || pnmatch(turn, "Black", 0) && pnmatch(black, alias, 0)) {

                if (!write_line("     It's your move.", local))

                    return(0);

            }



            else {

                sprintf(output, "     It's %s's move.", turn);

                if (!write_line(output, local))

                    return(0);

            }

        }



        write_line("\r\n ", local);



        v_line(local);



        for (i=0;i<4;i++) {

            rev_off(revoff, local);

            if (!write_line("    ", local))

                return(0);

            rev_on(revon, local);

            if (!write_line("    ", local)) {

                rev_off(revoff, local);

                return(0);

            }

        }



        rev_off(revoff, local);



        v_line(local);



        line++;



        if (line == 3) {

            sprintf(output, "     White: %s", white);

            if (!write_line(output, local))

                return(0);

        }



        if (line == 7) {

            if (!write_line("     Time Left: ", local))

                return(0);



            if (daysleft >= 0)

                sprintf(output, "%ld days %ld hrs %ld mins", daysleft, hours, mins);



            if (daysleft < 0)

                sprintf(output, "Expired");



            if (!write_line(output, local))

                return(0);



        }



        if (line == 11) {

            sprintf(output, "     White's Points: %d", board.wpoints);

            if (!write_line(output, local))

                return(0);

        }



        if (!write_line("\r\n", local))

            return(0);



        rank -= add;

        sprintf(output, "%d", rank);

        if (!write_line(output, local))

            return(0);



        v_line(local);



        box += row;



        for (i=0;i<4;i++) {

            box += add;

            get_piece(space, board.square[box]);

            rev_off(revoff, local);

            if (!write_line(space, local))

                return(0);

            box += add;

            get_piece(space, board.square[box]);

            rev_on(revon, local);

            if (!write_line(space, local)) {

                rev_off(revoff, local);

                return(0);

            }

        }



        box += row; /* used to make board display from left to right */



        rev_off(revoff, local);



        line++;



        v_line(local);



        if (line == 4) {

            sprintf(output, "     Black: %s", black);

            if (!write_line(output, local))

                return(0);

        }



        if (line == 12) {

            sprintf(output, "     Black's Points: %d", board.bpoints);

            if (!write_line(output, local))

                return(0);

        }



        if (line == 16 && board.check == 1) {

            if (pnmatch(turn, "White", 0) && pnmatch(white, alias, 0) || pnmatch(turn, "Black", 0) && pnmatch(black, alias, 0)) {

                if (!write_line("     You are in check.", local))

                    return(0);

            }



            else {

                sprintf(output, "     %s is in check.", turn);

                if (!write_line(output, local))

                    return(0);

            }

        }



        if (!write_line("\r\n", local))

            return(0);



    }



    board_bot(local);



    sprintf(output, "\r\n");



    if (!write_line(output, local))

        return(0);



    if (pnmatch(view, "White", 0)) {

        if (!write_line("   A   B   C   D   E   F   G   H\r\n", local))

            return(0);

    }



    else {

        if (!write_line("   H   G   F   E   D   C   B   A\r\n", local))

            return(0);

    }



    return(1);



}



board_top(local) int local;



{



    int i;



    write_char(' ', local);

    if (local == 1)

        write_char(' ', 2);



    write_char(ltop, local);



    if (local == 1)

        write_char('\360', 2);



    for (i=0;i<32;i++) {

        write_char(hline, local);

        if (local == 1)

            write_char('\360', 2);

    }



    write_char(rtop, local);

    if (local == 1)

        write_char('\360', 2);



}



board_bot(local) int local;



{



    int i;



    write_char(' ', local);

    if (local == 1)

        write_char(' ', 2);



    write_char(lbot, local);



    if (local == 1)

        write_char('\360', 2);



    for (i=0;i<32;i++) {

        write_char(hline, local);

        if (local == 1)

            write_char('\360', 2);

    }



    write_char(rbot, local);

    if (local == 1)

        write_char('\360', 2);



}



v_line(local) int local;



{



    write_char(vline, local);

    if (local == 1)

        write_char('|', 2);



}



write_char(c, local) char c; int local;



{



        if (local == 1 && cd_check() == 0)

            exit(0);



        while(Bcostat(local) == 0)

            continue;



        Bconout(local, c);



}



convert_coord(column, row) char column, row;



{



	int coord;



	if (column < 65 || column > 72)

		return(-1);



	if (row < 49 || row > 56)

		return(-1);



	coord = (column - 65) + ((row - 49) * 8);



	if (coord < 0 || coord > 63)

		return(-1);



	return(coord);



}



write_line(s, local) char *s; int local;



{

	int length, slength;

	char c;



	length = strlen(s);

	slength = 0;



	while (slength < length) {

		if (local == 1 && cd_check() == 0)

			exit(0);

		if (Bconstat(local) == -1 || Bconstat(2) == -1) {

			if (local == 1 && Bconstat(2) == -1)

				c = Bconin(2);

			if (Bconstat(local) == -1)

				c = Bconin(local);

			if (c == 'q' || c == 'Q' || c == 3)

				return(0);

			if (c == 19) {

				while (Bconstat(local) == 0 && Bconstat(2) == 0) {

					if (local == 1 && cd_check() == 0)

						exit(0);

				}



				if (Bconstat(local) == -1)

					c = Bconin(local);

				else

					c = Bconin(2);



				if (c == 3 || c == 'q' || c == 'Q')

					return(0);

			}



		}



		if (Bcostat(local) == -1) {

			Bconout(local, *s);

			if (local == 1)

				Bconout(2, *s);

			slength++;

			*s++;

		}

	}

}



char get_char(local) int local;



{



    char c;

    time_t lastchar, secs;

    int bell;



    bell = c = 0;



    time(&lastchar);



    while (c == 0) {



        if (local == 1 && cd_check() == 0)

            exit(0);



        time(&secs);



        if ((secs - lastchar) > 179) {

            Bconout(local, 7);

            write_line("\r\n\r\nTimed out due to inactivity!\r\n\r\n", local);

            exit(0);

        }



        if ((secs - lastchar) == 150 && !bell) {

            bell = 1;

            Bconout(local, 7);

        }



        if (Bconstat(local) == 0) {

            if (local == 1 && Bconstat(2) == -1)

                c = Bconin(2);

            else

                continue;

        }



        else

            c = Bconin(local); 



        bell = 0;

        time(&lastchar);



        if (c != 13 && c < 32)

            c = 0;



    }



    return(c);



}



get_line(s, length, local) char *s; int length, local;



{



    int slength, bell;

    time_t lastchar, secs;



    slength = 1;

    length += 2;

    bell = 0;



    time(&lastchar);



    while (slength < length) {



        if (local == 1 && cd_check() == 0)

            exit(0);



        time(&secs);



        if ((secs - lastchar) > 179) {

            Bconout(local, 7);

            write_line("\r\n\r\nTimed out due to inactivity!\r\n\r\n", local);

            exit(0);

        }



        if ((secs - lastchar) == 150 && !bell) {

            bell = 1;

            Bconout(local, 7);

        }



        if (Bconstat(local) == 0) {

            if (local == 1 && Bconstat(2) == -1)

                *s = Bconin(2);

            else

                continue;

        }



        else

            *s = Bconin(local); 



        bell = 0;

        time(&lastchar);



        if (*s < 32 && *s !=13 && *s !=8)

            continue;

        if (*s == '\b' || *s == 127) {

            if (slength > 1) {

                slength--;

                *s--;

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                if (local == 1) {

                    Bconout(2, 8);

                    Bconout(2, 32);

                    Bconout(2, 8);

                }

                continue;

            }

            else

                continue;

        }

        if (slength == (length - 1) && *s != '\r')

            continue;

        if (local == 1)

            Bconout(2, *s);

        Bconout(local, *s);

        if (*s == '\r') {

            Bconout(local, '\n');

            if (local == 1)

                Bconout(2, '\n');

            *s = 0;

            return(1);

        }    

        slength++;

        *s++;



    }



    *s = 0;



    return(1);



}



int cd_check()



{



char *gpip;

long stack;

char test;



   gpip=(char *)0xFFFFFA01L;

   stack=Super(0L);

   test= *gpip;    

   Super(stack);

   if (test & 2) 

      return(0);

   else

      return(1);

}



get_piece(space, square) char *space, square;



{



	if (square == ' ')

		strcpy(space, "    ");

	if (square == 'R')

		strcpy(space, " WR ");

	if (square == 'r')

		strcpy(space, " BR ");

	if (square == 'N')

		strcpy(space, " WN ");

	if (square == 'n')

		strcpy(space, " BN ");

	if (square == 'B')

		strcpy(space, " WB ");

	if (square == 'b')

		strcpy(space, " BB ");

	if (square == 'Q')

		strcpy(space, " WQ ");

	if (square == 'q')

		strcpy(space, " BQ ");

	if (square == 'K')

		strcpy(space, " WK ");

	if (square == 'k')

		strcpy(space, " BK ");

	if (square == 'P')

		strcpy(space, " WP ");

	if (square == 'p')

		strcpy(space, " BP ");



}



clear_screen(clear, local) char *clear; int local;



{



		int length, n;



		length = strlen(clear);



		for (n=0; n<length; n++) {

			Bconout(local, *clear);

			*clear++;

		}



		if (local == 1)

			write_line("E", 2);



}



rev_on(revon, local) char *revon; int local;



{



		int length, n;



		length = strlen(revon);



		for (n=0; n<length; n++) {

			Bconout(local, *revon);

			*revon++;

		}



		if (local == 1)

			write_line("p", 2);



}



rev_off(revoff, local) char *revoff; int local;



{



		int length, n;



		length = strlen(revoff);



		for (n=0; n<length; n++) {

			Bconout(local, *revoff);

			*revoff++;

		}



		if (local == 1)

			write_line("q", 2);



}



strip_string(string) char *string;



{



	while (*string != 0) {

		if (*string == 10 || *string == 13)

			*string = 0;

		*string++;

	}

}





change_alias(file, output, local, recpos, menu) 



char *file, *output; int local;

long recpos;

char *menu;



{



   /* CALIAS */



    char newalias[31], upalias[31], oldalias[31], ans;

    int n, dup, fd, bd;

    long bytesread;



    struct {

            char name[31];

	    char alias[31];

	    int games;

	    int wins;

	    int losses;

	    int draws;

    } bak;



    struct game {

        char white[31];

        char black[31];

        char turn[6];

    } members;



    bak.name[0] = bak.alias[0] = bak.games = bak.wins = bak.losses = bak.draws = 0;

    members.white[0] = members.black[0] = members.turn[0] = 0;



    sprintf(output, "%stccpplr.lst", file);



    fd = Fopen(output, 2);



    for (;;) {



        dup = 0;



        sprintf(output, "\"%s\" is %s'S current alias.\r\n\r\n", plr.alias, plr.name);

        write_line(output, local);

        write_line("Enter new alias: ", local);

        if (!get_line(newalias, 30, local))

            exit(0);



        if (newalias[0] == 0) {

            sprintf(newalias, plr.alias);

        }



        sprintf(output, "\r\n\"%s\", is this correct? (y/N) ", newalias);



        write_line(output, local);



        ans = get_char(local);



        if (ans == 'y' || ans == 'Y')

            write_line("Yes\r\n\r\n", local);

        else {

            write_line("No\r\n\r\n", local);

            continue;

        }



        sprintf(upalias, newalias);



        for(n=0; n<strlen(upalias); n++)

            upalias[n] = toupper(upalias[n]);



        sprintf(oldalias, plr.alias);



        for(n=0; n<strlen(oldalias); n++)

            oldalias[n] = toupper(oldalias[n]);



        if (pnmatch(newalias, plr.alias, 0)) {

            write_line("Alias unchanged.", local);

            Fclose(fd);

            return(0);

        }



        write_line("One moment...  Checking for duplication.\r\n\r\n", local);



        Fseek(0L, fd, 0);



	while((Fread(fd, (long) sizeof(bak), &bak)) > 0) {

            for (n=0;n<strlen(bak.alias);n++)

                bak.alias[n] = toupper(bak.alias[n]);

            if (pnmatch(oldalias, bak.alias, 0))

                continue;

            if (pnmatch(bak.alias, upalias, 0)) {

                dup = 1;

                break;

            }

        }



        if (dup) {

            write_line("That alias is already in use.\r\n\r\n", local);

            continue;

        }



        if (!dup)

            break;

    }



    write_line("Inserting new alias into data files...\r\n\r\n", local);



    sprintf(output, "%stccpgame.lst", file);



    bd = Fopen(output, 2);



    bytesread = 0;



    while(Fread(bd, (long) sizeof(members), &members) > 0) {

        if (pnmatch(members.white, plr.alias, 0)) {

            sprintf(members.white, newalias);

            Fseek(bytesread, bd, 0);

            Fwrite(bd, (long) sizeof(members), &members);

        }

        if (pnmatch(members.black, plr.alias, 0)) {

            sprintf(members.black, newalias);

            Fseek(bytesread, bd, 0);

            Fwrite(bd, (long) sizeof(members), &members);

        }

        bytesread = Fseek(0L, bd, 1);

    }



    Fclose(bd);



    Fseek(recpos, fd, 0);



    sprintf(plr.alias, newalias);



    Fwrite(fd, (long) sizeof(plr), &plr);



    Fclose(fd);



    create_menu(menu, output, file);



    write_line("New alias inserted.  Press any key to continue...", local);



    get_char(local);



    return(1);



}

