#include <stdio.h>

#include <osbind.h>

#include <time.h>

#include <bios.h>

#include <ctype.h>



struct {

    char square[65];

    int move;

    time_t move_date;

    char last_move[6];

    int d_pawn_move;

    int check;

    int wpoints;

    int bpoints;

    int draw;

    int wking, bking;

    int wqrook, wkrook, bqrook, bkrook;

    int wdraw, bdraw;

} back, board;



extern int games;



daily(file, output, history, news, hiscore, menu, local, nogame) 



char *file, *output, *history, *news, *hiscore, *menu;

int local, nogame;



{



        time_t curdate, timeleft;

        int chckmate, jgame, bp, fd, cnt;

        long n;

        

        struct {

            char white[31];

            char black[31];

            char turn[6];

        } members;



        members.white[0] = 0;

        members.black[0] = 0;

        members.turn[0] = 0;



        time(&curdate);



        sprintf(output, "%stccpgame.lst", file);



        fd = Fopen(output, 2);



        sprintf(output, "%cf", 27);

        write_line(output, 2);



        write_line("\r\n\r\nChecking game       ", 2);



        for (cnt=0;cnt<nogame;cnt++) {



            jgame = cnt + 1;



            sprintf(output, "\b\b\b\b\b\b%-3d...", jgame);



            write_line(output, 2);



            sprintf(output, "%stccpbrd.%d", file, jgame);



            if ((bp = Fopen(output, 2)) < 0)

                continue;



            Fread(bp, (long) sizeof(back), &back);



            Fseek(0L, bp, 0);



            Fread(bp, (long) sizeof(board), &board);



            Fseek(0L, bp, 0);



            timeleft = board.move_date;



            if (board.wdraw > 49 && board.bdraw > 49)

                board.draw = 3;



            if (curdate > timeleft || board.draw == 3) {



                Fseek((68L * (long) cnt), fd, 0);



                Fread(fd, (long) sizeof(members), &members);



                if (pnmatch(members.white, "No_Player", 0) || pnmatch(members.black, "No_Player", 0)) {

                    sprintf(output, "\r\n\r\nThe time for a player to fill the second slot in game %d has expired...", jgame);

                    write_line(output, 2);

                    Fclose(bp);

                    sprintf(output, "%stccpbrd.%d", file, jgame);

                    Fdelete(output);



                    if (!pnmatch(members.white, "No_Player", 0)) {

                        update_player(file, members.white, 0, 0, 0, output);

                    }

                    else {

                        update_player(file, members.black, 0, 0, 0, output);

                    }



                    sprintf(members.white, "No_Player");

                    sprintf(members.black, "No_Player");

                    sprintf(members.turn, "White");



                    Fseek((68L * (long) cnt), fd, 0);



                    Fwrite(fd, (long) sizeof(members), &members);    

                    write_line("\r\n\r\nChecking game       ", 2);

                    continue;

                } 



                sprintf(output, "\r\n\r\nCleaning up game %d between %s & %s...\r\n\r\n", jgame, members.white, members.black);

                write_line(output, 2);



                chckmate = checkmate(members.turn);



                if (chckmate == 2 || board.draw == 3 || board.draw == 1) {

                    update_player(file, members.white, 0, 0, 1, output);

                    update_player(file, members.black, 0, 0, 1, output);

                }



                else {

    

                    if (members.turn[0] == 'W') {

                        update_player(file, members.white, 0, 1, 0, output);

                        update_player(file, members.black, 1, 0, 0, output);

                    }



                    if (members.turn[0] == 'B') {

                        update_player(file, members.black, 0, 1, 0, output);

                        update_player(file, members.white, 1, 0, 0, output);

                    }



                }



                sprintf(output, "%stccpbrd.%d", file, jgame);

    

                Fclose(bp);



                Fdelete(output); /* delete game after processing */



                sprintf(output, "%s.%03d", history, jgame);



                bp = Fopen(output, 2);



                n = Fseek(0L, bp, 2);



                if (members.turn[0] == 'W') {

                    sprintf(output, "%5d", board.move);

                    Fwrite(bp, (long) strlen(output), output);

                }



                else    

                    Fseek((n-2L), bp, 0);



                sprintf(output, "  ");



                if (board.draw == 3 && !chckmate) 

                    strcat(output, "Game drawn by agreement\r\n");



                if (board.draw == 1 && !chckmate)

                    strcat(output, "Game drawn by default\r\n");



                if (chckmate == 1)

                    strcat(output, "Checkmate\r\n");



                if (chckmate == 2)

                    strcat(output, "Stalemate\r\n");



                if (curdate > timeleft && !chckmate && board.draw != 3 && board.draw != 1)

                    strcat(output, "Resigns\r\n");



                Fwrite(bp, (long) strlen(output), output);



                Fclose(bp);



                if (board.draw == 3 && !chckmate) {

                    sprintf(output, "Game %d:  %s and %s agree to a draw after %d moves.", jgame, members.white, members.black, board.move);

                    write_news(output, news);

                }



                if (board.draw == 1 && !chckmate) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s accepts by default %s's offer to draw after %d moves.", jgame, members.black, members.white, board.move);

                    else

                        sprintf(output, "Game %d:  %s accepts by default %s's offer to draw after %d moves.", jgame, members.white, members.black, board.move);

                    write_news(output, news);

                }



                if (chckmate == 1) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s checkmates %s in %d moves.", jgame, members.black, members.white, board.move);

                    else

                        sprintf(output, "Game %d:  %s checkmates %s in %d moves.", jgame, members.white, members.black, board.move);

                    write_news(output, news);

                }



                if (chckmate == 2) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s stalemates %s at move %d.  Game drawn.", jgame, members.black, members.white, board.move);

                    else

                        sprintf(output, "Game %d:  %s stalemates %s at move %d.  Game drawn.", jgame, members.white, members.black, board.move);        

                    write_news(output, news);

                }



                if (curdate > timeleft && !chckmate && board.draw != 3 && board.draw != 1) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s resigns to %s after %d moves.", jgame, members.white, members.black, board.move);

                    else

                        sprintf(output, "Game %d:  %s resigns to %s after %d moves.", jgame, members.black, members.white, board.move);

                    write_news(output, news);

                }



                sprintf(members.white, "No_Player");

                sprintf(members.black, "No_Player");

                sprintf(members.turn, "White");



                Fseek((68L * (long) cnt), fd, 0);



                Fwrite(fd, (long) sizeof(members), &members);    



                write_line("\r\n\r\nChecking game       ", 2);

            }



        }



        Fclose(fd);



        write_scores(hiscore, output, file);



        create_menu(menu, output, file);



        sprintf(output, "%ce", 27);

        write_line(output, 2);



        return(0);



}



play_game(file, output, local, clear, revon, revoff, alias, first, maxdays, history, hiscore, menu, news)



char *file, *output; int local; char *clear, *revon, *revoff;

char *alias, *first; int maxdays; char *history, *hiscore, *menu, *news;



{



    int fd, bp, n, jgame, status, move, i, start, end, chckmate, gscan;

    int z;



    char gameno[4], view[6], option[7], ans;

    time_t curdate, timeleft;



    struct {

        char white[31];

        char black[31];

        char turn[6];

    } members;



    members.white[0] = 0;

    members.black[0] = 0;

    members.turn[0] = 0;



    status = 1;

    gscan = 0;



    z = 0;



    sprintf(output, "%stccpgame.lst", file);



    fd = Fopen(output, 2);



    clear_screen(clear, local);



    if (games < 1) {

        sprintf(output, "Sorry, %s, you are not a participant in a game yet.\r\n", first);

        write_line(output, local);

        write_line("\r\nUse the 'J' option from the main menu to join a game.\r\n\r\n", local);

        write_line("Press ANY key to exit...", local);

        get_char(local);

        return(1);

    }



    while(status) {



        n = 0;



        Fseek(0L, fd, 0);



        if (gameno[0] == 'G' || gameno[0] == 'g') {



            n = jgame = 0;



            while(Fread(fd, (long) sizeof(members), &members) > 0 && jgame == 0) {



                n++;



                if (pnmatch(members.white, alias, 0) && pnmatch(members.turn, "White", 0) || pnmatch(members.black, alias, 0) && pnmatch(members.turn, "Black", 0))

                    jgame = n;



            }



            if (jgame == 0) {

                clear_screen(clear, local);

                gscan = 0;

                gameno[0] = 0;

                continue;

            }



        }



        if (gameno[0] != 'G' && gameno[0] != 'g') {



            sprintf(output, "%s, you are currently a player in the following game(s):\r\n\r\n", first);

            write_line(output, local);

            write_line("  Game  Status\r\n", local);

            write_line("  ----  ------\r\n", local);



            while(Fread(fd, (long) sizeof(members), &members) > 0) {



                n++;



                if (pnmatch(members.white, alias, 0) && !pnmatch(members.black, "No_Player", 0) || pnmatch(members.black, alias, 0) && !pnmatch(members.white, "No_Player", 0)) {

                    sprintf(output, "  %3d   ", n);

                    write_line(output, local);



                    if (pnmatch(members.white, alias, 0) && pnmatch(members.turn, "White", 0) || pnmatch(members.black, alias, 0) && pnmatch(members.turn, "Black", 0)) {

                        write_line("It's your move.", local);

                    }



                    write_line("\r\n", local);

                }



            }



            write_line("\r\nSelection (<return>=Exit, G=Global Scan): ", local);

            if (!get_line(gameno, 3, local))

                return(0);



            if (gameno[0] == 'G' || gameno[0] == 'g') {

                gscan = 1;

                continue;

            }



            jgame = atoi(gameno);



        }



        if (!jgame)

            break;



        Fseek((68L * (long) (jgame - 1)), fd, 0);



        Fread(fd, (long) sizeof(members), &members);    



        if (!pnmatch(members.white, alias, 0) && !pnmatch(members.black, alias, 0)) { 

            write_line("\r\nYou are not a player in that game!\r\n\r\n", local);

            continue;

        }



        if (pnmatch(members.white, alias, 0) && pnmatch(members.black, "No_Player", 0) || pnmatch(members.black, alias, 0) &&pnmatch(members.white, "No_Player", 0)) {

            sprintf(output, "\r\nSorry, %s, that game is still awaiting a player.\r\n\r\n", first);

            write_line(output, local);

            continue;

        }



        clear_screen(clear, local);



        if (pnmatch(members.white, alias, 0))

            strcpy(view, "White");

        else

            strcpy(view, "Black");



        sprintf(output, "%s%cremark.%d", file, view[0], jgame);



        if ((bp = Fopen(output, 0)) > -1) {



            if (pnmatch(view, "White", 0))

                sprintf(output, "Comments from %s:\r\n\r\n", members.black);

            else

                sprintf(output, "Comments from %s:\r\n\r\n", members.white);



            write_line(output, local);



            while((z = Fread(bp, 159L, output)) > 0) {

                output[z] = 0;

                if (!write_line(output, local)) {

                    break;

                }

            }



            Fclose(bp);



            ans = 0;



            while (ans != 13) {

                write_line("\r\nA=Answer, S=Save, @=Redisplay comment, <RETURN> to continue: ", local);

                ans = get_char(local);



                if (ans == 'a' || ans == 'A') {

                    write_line("\r\n\r\n", local);

                    comment(output, file, jgame, alias, local, view);

                }



                if (ans == '@') {

                    write_line("\r\n\r\n", local);

                    sprintf(output, "%s%cremark.%d", file, view[0], jgame);

                    show_file(output, local);

                }



                if (ans == 'S' || ans == 's')

                    break;

            }



            clear_screen(clear, local);



            if (ans != 'S' && ans != 's') {

                sprintf(output, "%s%cremark.%d", file, view[0], jgame);

                Fdelete(output);

            }



        }



        sprintf(output, "%stccpbrd.%d", file, jgame);



        bp = Fopen(output, 2);



        Fread(bp, (long) sizeof(back), &back);



        Fseek(0L, bp, 0);



        Fread(bp, (long) sizeof(board), &board);



        Fseek(0L, bp, 0);



        move = 0;



        if (!display_board(bp, output, local, jgame, revon, revoff, members.turn, members.white, members.black, alias, view, maxdays))

            write_line("\r\n", local);



        for (;;) {



            time(&curdate);



            timeleft = board.move_date;



            if (board.wdraw > 49 && board.bdraw > 49)

                board.draw = 3;



            if (curdate > timeleft || pnmatch(option, "Resign", 0) || board.draw == 3) {



                if (board.move == 1 && pnmatch(option, "Resign", 0)) {



                    write_line("\r\nResigning now will abort this game.  Do you still wish to procede? (y/N): ", local);

                    ans = get_char(local);

                    if (ans == 'n' || ans == 'N' || ans == 13) {

                        write_line("No\r\n\r\n", local);

                        option[0] = 0;

                        continue;

                    }

                    else {

                        write_line("Yes\r\n\r\nOne moment, please...\r\n", local);

                    }



                    write_player(output, file); /* save player stats */

                    update_player(file, members.white, 0, 0, 0, output);

                    update_player(file, members.black, 0, 0, 0, output);

                    read_player(output, file);

                    sprintf(output, "%stccpbrd.%d", file, jgame);

                    Fdelete(output);

                    sprintf(members.white, "No_Player");

                    sprintf(members.black, "No_Player");

                    sprintf(members.turn, "White");

                    Fseek((68L * (long) (jgame - 1)), fd, 0);

                    Fwrite(fd, (long) sizeof(members), &members);    

                    create_menu(menu, output, file);

                    sprintf(output, "%s.%03d", history, jgame);

                    Fdelete(output);

                    break;

                }



                if (curdate > timeleft)

                    write_line("\r\nMove time expired.  One moment...\r\n", local);



                if (option[0] == 'R')

                    write_line("\r\nResign.  One moment...\r\n", local);



                if (board.draw == 3)

                    write_line("\r\nGame drawn.  One moment...\r\n", local);



                chckmate = checkmate(members.turn);



                write_player(output, file); /* save player stats */



                if (chckmate == 2 || board.draw == 3 || board.draw == 1) {

                    update_player(file, members.white, 0, 0, 1, output);

                    update_player(file, members.black, 0, 0, 1, output);

                }



                else {

    

                    if (members.turn[0] == 'W') {

                        update_player(file, members.white, 0, 1, 0, output);

                        update_player(file, members.black, 1, 0, 0, output);

                    }



                    if (members.turn[0] == 'B') {

                        update_player(file, members.black, 0, 1, 0, output);

                        update_player(file, members.white, 1, 0, 0, output);

                    }



                }



                read_player(output, file); /* read updated stats into mem */



                Fclose(bp);



                sprintf(output, "%stccpbrd.%d", file, jgame);



                Fdelete(output); /* delete game after processing */



                sprintf(output, "%s.%03d", history, jgame);



                bp = Fopen(output, 2);



                n = Fseek(0L, bp, 2);



                if (members.turn[0] == 'W') {

                    sprintf(output, "%5d", board.move);

                    Fwrite(bp, (long) strlen(output), output);

                }



                else    

                    Fseek((n-2L), bp, 0);



                sprintf(output, "  ");



                if (board.draw == 3 && !chckmate) 

                    strcat(output, "Game drawn by agreement\r\n");



                if (board.draw == 1 && !chckmate)

                    strcat(output, "Game drawn by default\r\n");



                if (chckmate == 1)

                    strcat(output, "Checkmate\r\n");



                if (chckmate == 2)

                    strcat(output, "Stalemate\r\n");



                if (option[0] == 'R' && !chckmate || curdate > timeleft && !chckmate && board.draw != 3 && board.draw != 1)

                    strcat(output, "Resigns\r\n");



                Fwrite(bp, (long) strlen(output), output);



/*                Fclose(bp); */

/* No need for above because there is an Fclose(bp) after the loop - break */



                if (board.draw == 3 && !chckmate) {

                    sprintf(output, "Game %d:  %s and %s agree to a draw after %d moves.", jgame, members.white, members.black, board.move);

                    write_news(output, news);

                }



                if (board.draw == 1 && !chckmate) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s accepts by default %s's offer to draw after %d moves.", jgame, members.black, members.white, board.move);

                    else

                        sprintf(output, "Game %d:  %s accepts by default %s's offer to draw after %d moves.", jgame, members.white, members.black, board.move);

                    write_news(output, news);

                }



                if (chckmate == 1) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s checkmates %s in %d moves.", jgame, members.black, members.white, board.move);

                    else

                        sprintf(output, "Game %d:  %s checkmates %s in %d moves.", jgame, members.white, members.black, board.move);

                    write_news(output, news);

                }



                if (chckmate == 2) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s stalemates %s at move %d.  Game drawn.", jgame, members.black, members.white, board.move);

                    else

                        sprintf(output, "Game %d:  %s stalemates %s at move %d.  Game drawn.", jgame, members.white, members.black, board.move);        

                    write_news(output, news);

                }



                if (option[0] == 'R' && !chckmate || curdate > timeleft && !chckmate && board.draw != 3 && board.draw != 1) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s resigns to %s after %d moves.", jgame, members.white, members.black, board.move);

                    else

                        sprintf(output, "Game %d:  %s resigns to %s after %d moves.", jgame, members.black, members.white, board.move);

                    write_news(output, news);

                }



                sprintf(members.white, "No_Player");

                sprintf(members.black, "No_Player");

                sprintf(members.turn, "White");



                Fseek((68L * (long) (jgame - 1)), fd, 0);



                Fwrite(fd, (long) sizeof(members), &members);    



                write_scores(hiscore, output, file);



                create_menu(menu, output, file);



                break;



            }



            if (board.draw == 1 && members.turn[0] != view[0]) {



                if (members.turn[0] == 'W')

                    sprintf(output, "\r\n%s has offered a draw, accept? (y/N): ", members.white);

                else

                    sprintf(output, "\r\n%s has offered a draw, accept? (y/N): ", members.black);



                write_line(output, local);



                ans = get_char(local);

                sprintf(output, "%c\r\n", ans);

                write_line(output, local);



                if (ans == 'n' || ans == 'N' || ans == 13)

                    board.draw = 2;

                else

                    board.draw = 3;



                save_board(bp);



                continue;



            }



            write_line("\r\nOption (?=Help, <return>=Redisplay Board): ", local);



            if (!get_line(option, 6, local)) {

                if (!pnmatch(board.last_move, back.last_move, 0))

                    write_move(history, members.turn, jgame, start, end);

                return(0);

            }



            for (i=0;i<strlen(option);i++) {

                option[i] = toupper(option[i]);

            }



            if (option[0] == '?') {



                write_line("\r\n", local);

                if (!board.draw && members.turn[0] == view[0] && !board.check)

                    write_line("Draw ...... Offer Draw\r\n", local);

                if (!move && members.turn[0] == view[0] && board.draw != 1)

                    write_line("D2D4 ...... Make Move\r\n", local);

                if (gscan == 1)

                    write_line("Exit ...... Exit Scan\r\n", local);

                write_line("Mail ...... Send Mail\r\n", local);

                write_line("Quit ...... Quit\r\n", local);

                if (members.turn[0] == view[0] || board.move == 1)

                    write_line("Resign .... Resign\r\n", local);

                write_line("Read ...... Read Mail\r\n", local);

                write_line("Show ...... Show Moves\r\n", local);

                if (move) 

                    write_line("Undo ...... Undo Move\r\n", local);

            }



            if (pnmatch(option, "EXIT", 0) && gscan == 1) {

                if (!pnmatch(board.last_move, back.last_move, 0))

                    write_move(history, members.turn, jgame, start, end);

                gscan = 0;

                gameno[0] = 0;

                break;

            }



            if (pnmatch(option, "READ", 0)) {



                sprintf(output, "%s%cremark.%d", file, view[0], jgame);



                clear_screen(clear, local);



                if (show_file(output, local)) {

                    ans = 0;



                    while (ans != 13) {

                        write_line("\r\nA=Answer, S=Save, @=Redisplay comment, <RETURN> to continue: ", local);

                        ans = get_char(local);



                        if (ans == 'a' || ans == 'A') {

                            write_line("\r\n\r\n", local);

                            comment(output, file, jgame, alias, local, view);

                        }



                        if (ans == '@') {

                            write_line("\r\n\r\n", local);

                            sprintf(output, "%s%cremark.%d", file, view[0], jgame);

                            show_file(output, local);

                        }



                        if (ans == 'S' || ans == 's')

                            break;

                    }



                    clear_screen(clear, local);



                    if (ans != 'S' && ans != 's') {

                        sprintf(output, "%s%cremark.%d", file, view[0], jgame);

                        Fdelete(output);

                    }



                }



                else {

                    write_line("Sorry, no mail waiting.\r\n", local);

                }



            }



            if (pnmatch(option, "DRAW", 0) && members.turn[0] == view[0] && !board.draw) {



                if (board.check) {

                    write_line("\r\nYou cannot offer a draw while you are in check!\r\n", local);

                    continue;

                }



                if (board.move < 30) {

                    write_line("\r\nYou cannot offer a draw before the 30th move.\r\n", local);

                    continue;

                }



                if (board.draw == 2) {

                    write_line("\r\nYou must make a move before offering another draw!\r\n", local);

                    continue;

                }



                if (members.turn[0] == 'W')

                    sprintf(output, "\r\nOffer %s a draw? (y/N): ", members.black);

                else

                    sprintf(output, "\r\nOffer %s a draw? (y/N): ", members.white);



                write_line(output, local);



                ans = get_char(local);

                sprintf(output, "%c\r\n", ans);

                write_line(output, local);



                if (ans == 'y' || ans == 'Y') {

                    board.draw = 1;

                    time(&board.move_date);

                    board.move_date = board.move_date + (86400L * (long) maxdays);

                    save_board(bp);

                }



                continue;



            }



            if (option[0] == 'M') {

                clear_screen(clear, local);

                comment(output, file, jgame, alias, local, view);

            }



            if (pnmatch(option, "RESIGN", 0) && !pnmatch(members.turn, view, 0) && board.move > 1) {

                write_line("\r\nYou may not resign until it is your move!\r\n", local);

                option[0] = 0;

                continue;

            }



            if (pnmatch(option, "RESIGN", 0) && pnmatch(members.turn, view, 0) && board.move > 1)

                sprintf(option, "Resign");



            if (pnmatch(option, "RESIGN", 0) && board.move == 1)

                sprintf(option, "Resign");



/* The above condition allows players to always abort on the first move */



            if (option[0] == 'S') {

                clear_screen(clear, local);

                sprintf(output, "%s.%03d", history, jgame);

                show_file(output, local);



            }



            if (option[0] == 'Q') {

                if (!pnmatch(board.last_move, back.last_move, 0))

                    write_move(history, members.turn, jgame, start, end);

                break;

            }



            if (option[0] > 64 && option[0] < 73 && !move && board.draw != 1) {



/* Remove this section or add a #ifdef for the registered version



                if (board.move > 10) {

                    write_line("\r\nThe demo version allows only 10 moves in a game.  The registered version will\r\n",local);

                    write_line("allow you to continue this game...\r\n", local);

                    continue;

                }



#endif */



                if (!pnmatch(members.turn, view, 0)) {

                    write_line("\r\nIt is not your move.\r\n", local);

                    continue;

                }

                start = convert_coord(option[0], option[1]);

                end = convert_coord(option[2], option[3]);

                if (end == -1 || start == -1) {

                    write_line("\r\nInvalid move!\r\n", local);

                    continue;

                }

                if (!check_piece(start, members.turn)) {

                    write_line("\r\nYou don't have a piece there!\r\n", local);

                    continue;

                }



                if (!check_move(start, end)) {

                    write_line("\r\nInvalid move!\r\n", local);

                    continue;

                }



                board.square[end] = board.square[start];

                board.square[start] = 32;



                if (incheck(find_king(members.turn))) {

                    write_line("\r\nThat move would put you in check!  Try again...\r\n", local);

                    board.square[end] = back.square[end];

                    board.square[start] = back.square[start];

                    continue;

                }



                if (back.square[end] != ' ')

                    capture_piece(members.turn, end);



                if (board.d_pawn_move == -32767) {

                    if (members.turn[0] == 'W')

                        board.wpoints++;

                    else

                        board.bpoints++;

                }



                if (pnmatch(members.turn, "White", 0))

                    strcpy(members.turn, "Black");

                else {

                    board.move++;

                    strcpy(members.turn, "White");

                }



                board.check = incheck(find_king(members.turn));



                Fseek((68L * (long) (jgame - 1)), fd, 0);

                Fwrite(fd, (long) sizeof(members), &members);    



                board.last_move[0] = option[0];

                board.last_move[1] = option[1];

                board.last_move[2] = '-';

                board.last_move[3] = option[2];

                board.last_move[4] = option[3];

                board.last_move[5] = 0;



                if (start == 0 && board.wqrook == 0)

                    board.wqrook = 1;



                if (start == 7 && board.wkrook == 0)

                    board.wkrook = 1;



                if (start == 56 && board.bqrook == 0)

                    board.bqrook = 1;



                if (start == 63 && board.bkrook == 0)

                    board.bkrook = 1;



                if (start == 60 && board.bking == 0)

                    board.bking = 1;



                if (start == 4 && board.wking == 0)

                    board.wking = 1;



                if (back.square[start] == 'p' || back.square[start] == 'P' || board.wpoints > back.bpoints || board.bpoints > back.bpoints) {

                    if (isupper(back.square[start]))

                        board.wdraw = 0;

                    else

                        board.wdraw++;



                    if (islower(back.square[start]))

                        board.bdraw = 0;

                    else

                        board.bdraw++;

                }



                if (back.square[start] == 'p' && end < 8 || back.square[start] == 'P' && end > 55) {

                    write_line("\r\nPromote pawn to which piece (Q/r/b/n): ", local);

                    ans = get_char(local);



                    if (ans == 'Q' || ans == 'q') {

                        if (isupper (board.square[end]))

                            board.square[end] == 'Q';

                        else

                            board.square[end] == 'q';

                    }



                    if (ans == 'R' || ans == 'r') {

                        if (isupper(board.square[end]))

                            board.square[end] == 'R';

                        else

                            board.square[end] == 'r';

                    }



                    if (ans == 'B' || ans == 'b') {

                        if (isupper(board.square[end]))

                            board.square[end] == 'B';

                        else

                            board.square[end] == 'b';

                    }



                    if (ans == 'N' || ans == 'n') {

                        if (isupper(board.square[end]))

                            board.square[end] == 'N';

                        else

                            board.square[end] == 'n';

                    }



                    if (board.square[end] == 'P')

                        board.square[end] == 'Q';



                    if (board.square[end] == 'p')

                        board.square[end] == 'q';



                }



                if (back.d_pawn_move == board.d_pawn_move || board.d_pawn_move == -32767)

                    board.d_pawn_move = -999;



                time(&board.move_date);

                board.move_date = board.move_date + (86400L * (long) maxdays);

                save_board(bp);



                option[0] = 0;

                move = 1;



                board.draw = 0;



            }



            if (option[0] == 'U' && move) {

                Fseek(0L, bp, 0);

                Fwrite(bp, (long) sizeof(back), &back);

                Fseek(0l, bp, 0);

                Fread(bp, (long) sizeof(board), &board);



                if (pnmatch(members.turn, "White", 0))

                    strcpy(members.turn, "Black");

                else {

                    /* board.move++; removed because it's useless */

                    strcpy(members.turn, "White");

                }



                Fseek((68L * (long) (jgame - 1)), fd, 0);

                Fwrite(fd, (long) sizeof(members), &members);    



                option[0] = move = 0;

            }



            if (option[0] == 0)

                if (!display_board(bp, output, local, jgame, revon, revoff, members.turn, members.white, members.black, alias, view, maxdays))

                    write_line("\r\n", local);

        }



        clear_screen(clear, local);



    }



    Fclose(fd);

    Fclose(bp);



    return(1);



}



update_player(file, alias, wins, losses, draws, output)



char *file, *alias; int wins, losses, draws; char *output;



{



    int fd, status;

    long recpos;



    struct chess {

        char name[31];

        char alias[31];

        int games;

        int wins;

        int losses;

        int draws;

    } plr;



    plr.name[0] = plr.alias[0] = plr.games = plr.wins = plr.losses = 0;

    plr.draws = 0;



    sprintf(output, "%stccpplr.lst", file);



    fd = Fopen(output, 2);



    recpos = status = 0;



    while((Fread(fd, (long) sizeof(plr), &plr)) > 0) {

        if (pnmatch(plr.alias, alias, 0)) {

            status = 1;

            break;

        }



        recpos = Fseek(0L, fd, 1);



    }



    plr.wins += wins;

    plr.losses += losses;

    plr.draws += draws;

    plr.games--;



    Fseek(recpos, fd, 0);



    if (status) /* try and fix end record writing */

        Fwrite(fd, (long) sizeof(plr), &plr);



    Fclose(fd);



/* bug discovered which causes it to read through entire file and write an

extra file onto the end...  Either it is not finding a player or something...

but it looks correct....  Hmmm... */



}



checkmate(color) char *color;



{



    int i, n, end, status;

    char endsqr, piece;

    int kqmove[8] = {1, -1, 7, -7, 8, -8, 9, -9};

    int rook[4] = {1, -1, 8, -8};

    int bishop[4] = {7, -7, 9, -9};

    int knight[8] = {6, -6, 10, -10, 15, -15, 17, -17};

    int wpawn[6] = {8, 7, 9, 16};

    int bpawn[6] = {-8, -7, -9, -16};



    if (board.check)

        status = 1;

    else

        status = 2;



    for (i=0;i<64;i++) {

        piece = board.square[i];



        if (piece == ' ')

            continue;



        if (isupper(piece) && *color == 'B' || islower(piece) && *color == 'W')

            continue;



        if (piece == 'K' && *color == 'W' && i==4) {

            end = 6;

            if (check_move(i, end)) {

                if (!incheck(find_king(color)))

                    return(0);

                board.square[4] = 'K';

                board.square[7] = 'R';

                board.square[5] = board.square[6] = ' ';

            }

        }



        if (piece == 'K' && *color == 'W' && i==4) {

            end = 2;

            if (check_move(i, end)) {

                if (!incheck(find_king(color)))

                    return(0);

                board.square[4] = 'K';

                board.square[0] = 'R';

                board.square[2] = board.square[3] = ' ';

            }

        }



        if (piece == 'k' && *color == 'B' && i==60) {

            end = 58;

            if (check_move(i, end)) {

                if (!incheck(find_king(color)))

                    return(0);

                board.square[60] = 'k';

                board.square[56] = 'r';

                board.square[58] = board.square[59] = ' ';

            }

        }



        if (piece == 'k' && *color == 'B' && i==60) {

            end = 62;

            if (check_move(i, end)) {

                if (!incheck(find_king(color)))

                    return(0);

                board.square[60] = 'k';

                board.square[63] = 'r';

                board.square[61] = board.square[62] = ' ';

            }

        }



        if (piece == 'K' && *color == 'W' || piece == 'k' && *color == 'B') {

            for (n=0;n<8;n++) {

                end = i;

                for (;;) {

                    end += kqmove[n];

                    endsqr = board.square[end];

                    if (!check_move(i, end)) {

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                    board.square[i] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    board.square[i] = piece;

                    board.square[end] = endsqr;

                    break;

                }

            }

        }



        if (piece == 'Q' && *color == 'W' || piece == 'q' && *color == 'B') {

            for (n=0;n<8;n++) {

                end = i;

                for (;;) {

                    end += kqmove[n];

                    endsqr = board.square[end];

                    if (!check_move(end - kqmove[n], end)) {

                        board.square[end - kqmove[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                    board.square[end - kqmove[n]] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    if (isupper(piece) && islower(endsqr) || islower(piece) && isupper(endsqr)) {

                        board.square[end - kqmove[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                }

            }

        }



        if (piece == 'R' && *color == 'W' || piece == 'r' && *color == 'B') {

            for (n=0;n<4;n++) {

                end = i;

                for (;;) {

                    end += rook[n];

                    endsqr = board.square[end];

                    if (!check_move(end - rook[n], end)) {

                        board.square[end - rook[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                    board.square[end - rook[n]] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    if (isupper(piece) && islower(endsqr) || islower(piece) && isupper(endsqr)) {

                        board.square[end - rook[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                }

            }

        }



        if (piece == 'B' && *color == 'W' || piece == 'b' && *color == 'B') {

            for (n=0;n<4;n++) {

                end = i;

                for (;;) {

                    end += bishop[n];

                    endsqr = board.square[end];

                    if (!check_move(end - bishop[n], end)) {

                        board.square[end - bishop[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                    board.square[end - bishop[n]] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    if (isupper(piece) && islower(endsqr) || islower(piece) && isupper(endsqr)) {

                        board.square[end - bishop[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                }

            }

        }



        if (piece == 'N' && *color == 'W' || piece == 'n' && *color == 'B') {

            for (n=0;n<8;n++) {

                end = i;

                for (;;) {

                    end += knight[n];

                    endsqr = board.square[end];

                    if (!check_move(i, end)) {

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                    board.square[i] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    board.square[i] = piece;

                    board.square[end] = endsqr;

                    break;

                }

            }

        }



        if (piece == 'P' && *color == 'W') {

            for (n=0;n<4;n++) {

                end = i;

                for (;;) {

                    end += wpawn[n];

                    endsqr = board.square[end];

                    if (!check_move(i, end)) {

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        if (back.d_pawn_move > -1) {

                            board.square[back.d_pawn_move] = back.square[back.d_pawn_move];

                            board.d_pawn_move = back.d_pawn_move;

                        }

                        break;

                    }

                    board.square[i] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    board.square[i] = piece;

                    board.square[end] = endsqr;

                    if (back.d_pawn_move > -1) {

                        board.square[back.d_pawn_move] = back.square[back.d_pawn_move];

                        board.d_pawn_move = back.d_pawn_move;

                    }

                    break;

                }

            }

        }



        if (piece == 'p' && *color == 'B') {

            for (n=0;n<4;n++) {

                end = i;

                for (;;) {

                    end += bpawn[n];

                    endsqr = board.square[end];

                    if (!check_move(i, end)) {

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        if (back.d_pawn_move > -1) {

                            board.square[back.d_pawn_move] = back.square[back.d_pawn_move];

                            board.d_pawn_move = back.d_pawn_move;

                        }

                        break;

                    }

                    board.square[i] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    board.square[i] = piece;

                    board.square[end] = endsqr;

                    if (back.d_pawn_move > -1) {

                        board.square[back.d_pawn_move] = back.square[back.d_pawn_move];

                        board.d_pawn_move = back.d_pawn_move;

                    }

                    break;

                }

            }

        }

    }



    return(status);



}



write_move(history, color, gameno, start, end) char *history, *color; 

int gameno, start, end;



{



    int fd;

    char line[50], output[50];

    register long n;



    sprintf(line, "%s.%03d", history, gameno);



    if ((fd = Fopen(line, 2)) < 0)

        return(0);



    n = Fseek(0L, fd, 2);



    if (*color == 'B') {

        sprintf(line, "%5d", board.move);

        Fwrite(fd, (long) strlen(line), line);

    }



    else

        Fseek((n-2L), fd, 0);



    sprintf(line, "  ");



    Fwrite(fd, (long) strlen(line), line);



    sprintf(line, "%s", board.last_move);



    if (back.square[end] != ' ') {

            strcat(line, " (");

            if (back.square[start] == 'K' || back.square[start] == 'k')

                strcat(line, "King");

            if (back.square[start] == 'Q' || back.square[start] == 'q')

                strcat(line, "Queen");

            if (back.square[start] == 'R' || back.square[start] == 'r')

                strcat(line, "Rook");

            if (back.square[start] == 'B' || back.square[start] == 'b')

                strcat(line, "Bishop");

            if (back.square[start] == 'N' || back.square[start] == 'n')

                strcat(line, "Knight");

            if (back.square[start] == 'P' || back.square[start] == 'p')

                strcat(line, "Pawn");

            strcat(line, " x ");

            if (back.square[end] == 'K' || back.square[end] == 'k')

                strcat(line, "King");

            if (back.square[end] == 'Q' || back.square[end] == 'q')

                strcat(line, "Queen");

            if (back.square[end] == 'R' || back.square[end] == 'r')

                strcat(line, "Rook");

            if (back.square[end] == 'B' || back.square[end] == 'b')

                strcat(line, "Bishop");

            if (back.square[end] == 'N' || back.square[end] == 'n')

                strcat(line, "Knight");

            if (back.square[end] == 'P' || back.square[end] == 'p')

                strcat(line, "Pawn");

            strcat(line, ")");

    }



    if (board.d_pawn_move == -32767)

        strcat(line, " (Pawn x Pawn)");



    if (back.square[start] == 'K' && start == 4 && end == 6)

        strcat(line, " (Castles Short)");



    if (back.square[start] == 'K' && start == 4 && end == 2)

        strcat(line, " (Castles Long)");



    if (back.square[start] == 'k' && start == 60 && end == 62)

        strcat(line, " (Castles Short)");



    if (back.square[start] == 'k' && start == 60 && end == 58)

        strcat(line, " (Castles Long)");



    if (board.check)

        strcat(line, " Check!");



    sprintf(output, "%-35s\r\n", line);



    Fwrite(fd, (long) strlen(output), output);



    Fclose(fd);



}



capture_piece(color, end) char *color; int end;



{



    int value;



    value = 0;



    if (back.square[end] == 'Q' || back.square[end] == 'q')

        value = 9;

    if (back.square[end] == 'R' || back.square[end] == 'r')

        value = 5;

    if (back.square[end] == 'B' || back.square[end] == 'b')

        value = 3;

    if (back.square[end] == 'N' || back.square[end] == 'n')

        value = 3;

    if (back.square[end] == 'P' || back.square[end] == 'p')

        value = 1;



    if (*color == 'W')

        board.wpoints += value;

    else

        board.bpoints += value;



}



find_king(color) char *color;



{



    register int i;



    for (i=0;i<64;i++) {

        if (*color == 'W' && board.square[i] == 'K')

            break;

        if (*color == 'B' && board.square[i] == 'k')

            break;

    }



    return(i);



}



incheck(start) int start;



{



    register int i;

    int endrow, startrow, endcol, startcol;



    for (i=start;;i--) {

        endrow = i/8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='r')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start - 1)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start - 1)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='R')

                return(1);

            break;

        }



        if (endcol == 0)

            break;



    }





    for (i=start;;i++) {

        endrow = i/8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='r') 

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start + 1)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start + 1)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='R')

                return(1);

            break;

        }



        if (endcol == 7)

            break;



    }



    for (i=start;;i+=-8) {

        endrow = i/8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='r')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start - 8)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start - 8)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='R')

                return(1);

            break;

        }



        if (endrow == 0)

            break;



    }



    for (i=start;;i+=8) {

        endrow = i / 8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='r')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start + 8)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start + 8)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='R')

                return(1);

            break;

        }



        if (endrow == 7)

            break;



    }



    for (i=start;;i+=7) {

        endrow = i / 8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='b')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='p' && i == start + 7)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start + 7)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start + 7)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='B')

                return(1);

            break;

        }



        if (endcol == 0 || endrow == 7)

            break;

    }



    for (i=start;;i+=-7) {

        endrow = i / 8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='B')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='P' && i == start - 7)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start - 7)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start - 7)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='b')

                return(1);

            break;

        }



        if (endcol == 7 || endrow == 0)

            break;



    }



    for (i=start;;i+=9) {

        endrow = i/8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='b')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='p' && i == start + 9)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start + 9)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start + 9)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='B')

                return(1);

            break;

        }



        if (endcol == 7 || endrow == 7)

            break;



    }



    for (i=start;;i+=-9) {

        endrow = i/8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='B')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='P' && i == start - 9)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start - 9)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start - 9)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='b')

                return(1);

            break;

        }



        if (endcol == 0 || endrow == 0)

            break;



    }



    startrow = start / 8;

    startcol = start - (startrow * 8);



    i = start - 17;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i > -1 && endcol < startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start - 15;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i > -1 && endcol > startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start + 17;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i < 64 && endcol > startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start + 15;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i < 64 && endcol < startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start + 10;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i < 64 && endcol > startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start + 6;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i < 64 && endcol < startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start - 6;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i > -1 && endcol > startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start - 10;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i > -1 && endcol < startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    return(0);



}



check_move(start, end)



int start, end;



{



    int srow, erow, scol, ecol;



    srow = start / 8;

    erow = end / 8;

    scol = start - (srow * 8);

    ecol = end - (erow * 8);



    if (start==end)

        return(0);



    if (start == 4 && end == 6 && board.square[4] == 'K') {

        if (board.wking == 1 || board.wkrook == 1)

            return(0);

        if (board.square[5] != ' ' || board.square[6] != ' ' || board.square[7] != 'R')

            return(0);

        board.square[4] = ' ';

        board.square[5] = 'K';

        if (incheck(5)) {

            board.square[4] = 'K';

            board.square[5] = ' ';

            return(0);

        }

        board.square[5] = ' ';

        board.square[6] = 'K';

        if (incheck(6)) {

            board.square[4] = 'K';

            board.square[6] = ' ';

            return(0);

        }

        board.square[4] = 'K';

        board.square[6] = ' ';

        board.square[7] = ' ';

        board.square[5] = 'R';

        board.wking = 1;

        board.wkrook = 1;



        return(1);

    }



    if (start == 4 && end == 2 && board.square[4] == 'K') {

        if (board.wking == 1 || board.wqrook == 1)

            return(0);

        if (board.square[1] != ' ' || board.square[2] != ' ' || board.square[3] != ' ' || board.square[0] != 'R')

            return(0);

        board.square[4] = ' ';

        board.square[3] = 'K';

        if (incheck(3)) {

            board.square[4] = 'K';

            board.square[3] = ' ';

            return(0);

        }

        board.square[3] = ' ';

        board.square[2] = 'K';

        if (incheck(2)) {

            board.square[4] = 'K';

            board.square[2] = ' ';

            return(0);

        }

        board.square[4] = 'K';

        board.square[2] = ' ';

        board.square[0] = ' ';

        board.square[3] = 'R';

        board.wking = 1;

        board.wqrook = 1;



        return(1);

    }



    if (start == 60 && end == 58 && board.square[60] == 'k') {

        if (board.bking == 1 || board.bqrook == 1)

            return(0);

        if (board.square[57] != ' ' || board.square[58] != ' ' || board.square[59] != ' ' || board.square[56] != 'r')

            return(0);

        board.square[60] = ' ';

        board.square[59] = 'k';

        if (incheck(59)) {

            board.square[60] = 'k';

            board.square[59] = ' ';

            return(0);

        }

        board.square[59] = ' ';

        board.square[58] = 'k';

        if (incheck(58)) {

            board.square[60] = 'k';

            board.square[59] = ' ';

            return(0);

        }

        board.square[60] = 'k';

        board.square[58] = ' ';

        board.square[56] = ' ';

        board.square[59] = 'r';

        board.bking = 1;

        board.bqrook = 1;



        return(1);

    }



    if (start == 60 && end == 62 && board.square[60] == 'k') {

        if (board.bking == 1 || board.bkrook == 1)

            return(0);

        if (board.square[61] != ' ' || board.square[62] != ' ' || board.square[63] != 'r')

            return(0);

        board.square[60] = ' ';

        board.square[61] = 'k';

        if (incheck(61)) {

            board.square[60] = 'k';

            board.square[61] = ' ';

            return(0);

        }

        board.square[61] = ' ';

        board.square[62] = 'k';

        if (incheck(62)) {

            board.square[60] = 'k';

            board.square[62] = ' ';

            return(0);

        }

        board.square[60] = 'k';

        board.square[62] = ' ';

        board.square[63] = ' ';

        board.square[61] = 'r';

        board.bking = 1;

        board.bkrook = 1;



        return(1);



    }



    if (board.square[start] == 'Q' || board.square[start] == 'q')

        return(queen_move(board.square, start, end, srow, erow, scol, ecol));



    if (board.square[start] == 'R' || board.square[start] == 'r')

        return(rook_move(board.square, start, end, srow, erow, scol, ecol));



    if (board.square[start] == 'B' || board.square[start] == 'b')

        return(bishop_move(board.square, start, end, srow, erow, scol, ecol));



    if (board.square[start] == 'K' || board.square[start] == 'k')

        return(king_move(board.square, start, end, srow, erow, scol, ecol));



    if (board.square[start] == 'N' || board.square[start] == 'n')

        return(knight_move(board.square, start, end, srow, erow, scol, ecol));



    if (board.square[start] == 'P' || board.square[start] == 'p')

        return(pawn_move(board.square, start, end, srow, erow, scol, ecol));

}



pawn_move(square, start, end, srow, erow, scol, ecol)



char *square; int start, end, srow, erow, scol, ecol;



{



    int add, pdouble, i, enpass;



    enpass = add = 0;

    pdouble = -999;



    if (isupper(square[start]) && erow==srow+1 && ecol==scol && board.square[end] == ' ')

        add = 8;



    if (islower(square[start]) && erow==srow-1 && ecol==scol && board.square[end] == ' ')

        add = -8;



    if (isupper(square[start]) && start > 7 && start < 16 && erow==srow+2 && board.square[end] == ' ') {

        add = 8;

        pdouble = end;

    }



    if (islower(square[start]) && start >47 && start < 56 && erow==srow-2 && board.square[end] == ' ') {

        add = -8;

        pdouble = end;

    }



    if (isupper(square[start]) && erow==srow+1 && ecol==scol+1 && islower(square[end]))

        add = 9;



    if (isupper(square[start]) && erow==srow+1 && ecol==scol-1 && islower(square[end]))

        add = 7;



    if (islower(square[start]) && erow==srow-1 && ecol==scol+1 && isupper(square[end]))

        add = -7;



    if (islower(square[start]) && erow==srow-1 && ecol==scol-1 && isupper(square[end]))

        add = -9;



    if (isupper(square[start]) && erow==srow+1 && ecol==scol+1 && board.d_pawn_move + 8 == end && board.square[end] == ' ') {

        enpass = 1;

        add = 9;

    }



    if (isupper(square[start]) && erow==srow+1 && ecol==scol-1 && board.d_pawn_move + 8 == end && board.square[end] == ' ') {

        enpass = 1;

        add = 7;

    }



    if (islower(square[start]) && erow==srow-1 && ecol==scol+1 && board.d_pawn_move - 8 == end && board.square[end] == ' ') {

        enpass = 1;

        add = -7;

    }



    if (islower(square[start]) && erow==srow-1 && ecol==scol-1 && board.d_pawn_move - 8 == end && board.square[end] == ' ') {

        enpass = 1;

        add = -9;

    }



    if (!add)

        return(0);



    for (i=start;;) {



        i += add;



        if (i == end)

            break;



        if (square[i] != ' ')

            return(0);

    }



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    board.d_pawn_move = pdouble;



    if (enpass) {

        board.square[board.d_pawn_move] = ' ';

        board.d_pawn_move = -32767; /* indicates en passant capture */

    }



    return(1);



}



king_move(square, start, end, srow, erow, scol, ecol) char *square; int start, end, srow, erow, scol, ecol;



{



    int add;



    add = 0;



    if (erow==srow && ecol==scol+1)

        add = 1;



    if (erow==srow && ecol==scol-1)

        add = -1;



    if (erow==srow+1 && ecol==scol)

        add = 8;



    if (erow==srow-1 && ecol==scol)

        add = -8;



    if (erow==srow+1 && ecol==scol+1)

        add = 9;



    if (erow==srow+1 && ecol==scol-1)

        add = 7;



    if (erow==srow-1 && ecol==scol+1)

        add = -7;



    if (erow==srow-1 && ecol==scol-1)

        add = -9;



    if (!add)

        return(0);



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    return(1);



}



knight_move(square, start, end, srow, erow, scol, ecol) char *square; int start, end, srow, erow, scol, ecol;



{



    int add;



    add = 0;



    if (erow==srow+2 && ecol==scol+1)

        add = 17;



    if (erow==srow+2 && ecol==scol-1)

        add = 15;



    if (erow==srow-2 && ecol==scol+1)

        add = -15;



    if (erow==srow-2 && ecol==scol-1)

        add = -17;



    if (erow==srow+1 && ecol==scol+2)

        add = 10;



    if (erow==srow+1 && ecol==scol-2)

        add = 6;



    if (erow==srow-1 && ecol==scol+2)

        add = -6;



    if (erow==srow-1 && ecol==scol-2)

        add = -10;



    if (!add)

        return(0);



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    return(1);

}



bishop_move(square, start, end, srow, erow, scol, ecol) char *square; int start, end, srow, erow, scol, ecol;



{



    int add, i;



    add = 0;



    if (erow>srow && ecol==(scol+(erow-srow))) {

        add = 9;

    }



    if (erow<srow && ecol==(scol-(srow-erow))) {

        add = -9;

    }



    if (erow>srow && ecol==(scol-(erow-srow))) {

        add = 7;

    }



    if (erow<srow && ecol==(scol+(srow-erow))) {

        add = -7;

    }



    if (!add)

        return(0);



    for (i=start;;) {



        i += add;



        if (i == end)

            break;



        if (square[i] != ' ')

            return(0);

    }



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    return(1);



}



rook_move(square, start, end, srow, erow, scol, ecol) char *square; int start, end, srow, erow, scol, ecol;



{



    int add, i;



    add = 0;



    if (erow==srow && ecol>scol) {

        add = 1;

    }



    if (erow==srow && ecol<scol) {

        add = -1;

    }



    if (ecol==scol && erow>srow) {

        add = 8;

    }



    if (ecol==scol && erow<srow) {

        add = -8;

    }



    if (!add)

        return(0);



    for (i=start;;) {



        i += add;



        if (i == end)

            break;



        if (square[i] != ' ')

            return(0);

    }



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    return(1);



}



queen_move(square, start, end, srow, erow, scol, ecol) char *square; int start, end, srow, erow, scol, ecol;



{



    int add, i;



    add = 0;



    if (erow==srow && ecol>scol) {

        add = 1;

    }



    if (erow==srow && ecol<scol) {

        add = -1;

    }



    if (ecol==scol && erow>srow) {

        add = 8;

    }



    if (ecol==scol && erow<srow) {

        add = -8;

    }



    if (erow>srow && ecol==(scol+(erow-srow))) {

        add = 9;

    }



    if (erow<srow && ecol==(scol-(srow-erow))) {

        add = -9;

    }



    if (erow>srow && ecol==(scol-(erow-srow))) {

        add = 7;

    }



    if (erow<srow && ecol==(scol+(srow-erow))) {

        add = -7;

    }



    if (!add)

        return(0);



    for (i=start;;) {



        i += add;



        if (i == end)

            break;



        if (square[i] != ' ')

            return(0);

    }



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    return(1);



}



convert_coord(column, row) char column, row;



{



    int coord;



    if (column < 65 || column > 72)

        return(-1);



    if (row < 49 || row > 56)

        return(-1);



    coord = (column - 65) + ((row - 49) * 8);



    if (coord < 0 || coord > 63)

        return(-1);



    return(coord);



}



check_piece(start, color) int start, *color;



{



    if (pnmatch(color, "White", 0)) {

        if (board.square[start] > 65 && board.square[start] < 83)

            return(1);

    }



    else {

        if (board.square[start] > 97 && board.square[start] < 115)

 